<?php

namespace App\Controller;

use App\Entity\CatalogoGastos;
use App\Entity\Empleados;
use App\Entity\Gastos;
use App\Entity\Ingresos;
use App\Entity\Menus;
use App\Entity\Mesas;
use App\Entity\ModoPagos;
use App\Entity\Servicios;
use App\Entity\Tickets;
use App\Entity\Usuarios;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use phpDocumentor\Reflection\Types\This;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpParser\Node\Expr\New_;
use PhpParser\Node\Stmt\Return_;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use PhpOffice\PhpSpreadsheet\Style\Alignment;

class GastosController extends AbstractController
{
    #[Route('/nuevoGasto', name: 'nuevoGasto')]
    public function nuevoGasto(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $ideCatGast = $request->get('ideCatGast');
                $fechaTicket = $request->get('fechaTicket');
                $horaTicket = $request->get('horaTicket');
                $totMon = $request->get('totMon');
                $ideEmpleado = $session->get('ideUsuario');
                $cveModoPag = $request->get('modoPag');

                $ideModoPago = $em->getRepository(ModoPagos::class)->findOneBy(['ideModPag' => $cveModoPag]);

                $catalogoGasto = $em->getRepository(CatalogoGastos::class)
                    ->findOneBy(['ideCatGast' => $ideCatGast]);

                $empleado = $em->getRepository(Usuarios::class)
                    ->findOneBy(['ideUsu' => $ideEmpleado]);

                $gasto = new Gastos();
                $gasto->setCveCatGast($catalogoGasto);
                $gasto->setDescGast("");
                $gasto->setFecMovGast(new \DateTime($fechaTicket));
                $gasto->setHorMovGast(new \DateTime($horaTicket)); // new \DateTime(date('H:i:s'))
                $gasto->setTotMon($totMon);
                $gasto->setFolTic("");
                $gasto->setHorMov(new \DateTime(date('H:i:s')));
                $gasto->setRutImagTic('Imagen');
                $gasto->setFecMov(new \DateTime(date('Y-m-d')));
                $gasto->setCveEmp($empleado);
                $gasto->setCveTipoPago($ideModoPago);
                $em->persist($gasto);
                $em->Flush();


                //$gastos = $em->getRepository(Gastos::class)->findAll();

                $fecha = new \DateTime();

                $primerDia = $fecha->modify('first day of this month')->format('Y/m/d');
                $ultimoDia = $fecha->modify('last day of this month')->format('Y/m/d');


                //SELECT *
                // FROM gastos g,
                // catalogo_gastos cg
                // WHERE g.cve_cat_gast = cg.ide_cat_gast
                // AND g.fec_mov BETWEEN '2022-01-01' AND '2023-12-01'
                // ORDER BY cg.descripcion ASC;


                $dql = "SELECT g "
                    . "FROM App\Entity\Gastos g, App\Entity\CatalogoGastos cg "
                    . "WHERE g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMov BETWEEN "
                    . "'" . $primerDia . "'"
                    . " AND "
                    . "'" . $ultimoDia . "'"
                    . "ORDER BY cg.descripcion ASC";

                $query = $entityManager->createQuery($dql);
                $gastos = $query->getResult();

                /* $dqlR = "SELECT "
                     . "cg.descripcion DESCRIPCION, "
                     . "SUM(g.totMon) SUMA, "
                     . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                     . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                     . "WHERE "L

                     . "g.cveCatGast = cg.ideCatGast "
                     . "AND g.fecMov "
                     . "BETWEEN "
                     . "' " . $primerDia . "' "
                     . "AND"
                     . "' " . $ultimoDia . "' "
                     . "GROUP BY cg.descripcion "
                     . "ORDER BY cg.descripcion ASC";
                 $query = $entityManager->createQuery($dqlR);
                 $resumenG = $query->getResult();*/

                return $this->render('Gastos/tabla_gastos.html.twig', ['gastos' => $gastos]);
                //return $this->render('Gastos/formulario_gastos.html.twig', ['gasto' => $gastos, 'resumenG' => $resumenG]);
            } else { //es GET
                $em = $doctrine->getManager();

                $fecha = new \DateTime();

                $primerDia = $fecha->modify('first day of this month')->format('Y/m/d');
                $ultimoDia = $fecha->modify('last day of this month')->format('Y/m/d');

                $dql = "SELECT g "
                    . "FROM App\Entity\Gastos g, App\Entity\CatalogoGastos cg "
                    . "WHERE g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMovGast BETWEEN "
                    . "'" . $primerDia . "'"
                    . " AND "
                    . "'" . $ultimoDia . "'"
                    . "ORDER BY cg.descripcion ASC";

                $query = $entityManager->createQuery($dql);
                $gastos = $query->getResult();

                $dqlR = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(2) ) "
                    . "AND g.fecMovGast "
                    . "BETWEEN "
                    . "' " . $primerDia . "' "
                    . "AND"
                    . "' " . $ultimoDia . "' "
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlR);
                $resumenG = $query->getResult();

                $dqlT = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(1) ) "
                    . "AND g.fecMovGast "
                    . "BETWEEN "
                    . "' " . $primerDia . "' "
                    . "AND"
                    . "' " . $ultimoDia . "' "
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlT);
                $gastosTrans = $query->getResult();

                $catalogoGasto = $em->getRepository(CatalogoGastos::class)
                    ->findBy([], ['descripcion' => 'ASC']);
                $cveModPag = $em->getRepository(ModoPagos::class)->findAll();

                return $this->render('Gastos/formulario_gastos.html.twig',
                    [
                        'resumenG' => $resumenG,
                        'gastos' => $gastos,
                        'gasto' => $catalogoGasto,
                        'pagos' => $cveModPag,
                        'gastosT' => $gastosTrans
                    ]
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirGastos', name: 'imprimir_Gastos')]
    public function imprimirGasto(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $Dia = $request->get('Fecha');
                if ($Dia == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = $Dia;
                }
                $gastos = $em->getRepository(Gastos::class)
                    ->findBy(['fecMov' => new \DateTime($hoy)]);

                $pdf = new PdfReportes('P', 'mm', "letter");
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->generarReportes($gastos, $hoy);

                return new Response(
                    $pdf->Output('gasto_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirGastosMes', name: 'imprimir_Gastos_Mes')]
    public function imprimirGastosMes(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $Mes = $request->get('corteMes');
                $primer_Dia = $Mes . "-01";
                //print_r($primer_Dia);
                $Ultimo_dia = new \DateTime($primer_Dia);
                $Ultimo_dia->modify('Last day of this month');
                //print_r($Ultimo_dia->format('d/m/Y')); // imprime por ejemplo: 01/12/2012

                $dql = "SELECT "
                    . "g  "
                    . "FROM App\Entity\Gastos g "
                    . "WHERE "
                    . "g.fecMovGast "
                    . "BETWEEN "
                    . "'" . $primer_Dia . "'"
                    . " AND  "
                    . "'" . $Ultimo_dia->format('Y/m/d') . "'";

                $query = $entityManager->createQuery($dql);
                $g = $query->getResult();

                $dqlR = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(1) ) "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMovGast "
                    . "BETWEEN "
                    . "'" . $primer_Dia . "'"
                    . " AND  "
                    . "'" . $Ultimo_dia->format('Y/m/d') . "'"
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlR);
                $resumenG = $query->getResult();

                $dqlT = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(2) ) "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMovGast "
                    . "BETWEEN "
                    . "'" . $primer_Dia . "'"
                    . " AND  "
                    . "'" . $Ultimo_dia->format('Y/m/d') . "'"
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlT);
                $resumenGT = $query->getResult();

                $pdf = new PdfNotas('L', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->imprimirGastosMes($g, $Mes, $resumenG, $resumenGT);
                return new Response(
                    $pdf->Output('gastosMes_' . $Mes . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/subirImagen', name: 'subirImagen')]
    public function SubirImagen(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();
                $ideGast = $request->get('ideGast');
                // $tick = $request->get('tick');

                $gastos = $em->getRepository(Gastos::class)
                    ->findOneBy(['ideGast' => $ideGast]);


                $rutaBase = 'TICKETS/' . $ideGast;
                $rutaFinal = $rutaBase . "/" . $_FILES['ArchivoTicket']['name'];


                //'TICKETS/1/cardenal-02.png'

                if (file_exists($rutaBase)) {

                } else {

                    /// CREAR EL DIRECTORIO//
                    mkdir("TICKETS/" . $ideGast);
                }
                $bandera = false;

                if ($_FILES['ArchivoTicket']['error'] > 0) {

                } else {
                    $bandera = move_uploaded_file($_FILES['ArchivoTicket']['tmp_name'], $rutaFinal);

                }
                if ($bandera == true) {
                    // REGISTRO EN LA BASE DE DATOS
                    $cat = new Tickets();
                    $cat->setCveGasto($gastos);
                    $cat->setRutaImagen($rutaFinal);

                    $em->persist($cat);
                    $em->flush();

                    return $this->redirect($this->generateUrl('home_page'));
                }
            }
        }
    }

    #[Route('/pintarImagen', name: 'pintarImagen')]
    public function pintarImagen(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $ideGas = $request->get('ideGas');

                $tickets = $em->getRepository(Tickets::class)
                    ->findBy(['cveGasto' => $ideGas]);


                return $this->render('Gastos/tickets.html.twig',
                    ['tickets' => $tickets]
                );

            }
        }
    }

    /* #[Route('/registroGast', name: 'registroGast')]
     public function registroGast(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
     {

         $session = $request->getSession();
         if ($session->has('ideUsuario')) {
             if ($request->getMethod() == 'POST') {

                 $em = $doctrine->getManager();

                 $descripcion = $request->get('descripcion');

                 $gast = new CatalogoGastos();
                 $gast->setDescripcion($descripcion);

                 $em->persist($gast);
                 $em->flush();


                 return $this->render('Gastos/respuesta-alta-gasto.html.twig');

             } else { //es GET
                 $em = $doctrine->getManager();

                 return $this->redirect($this->generateUrl('login'));
             }


         }
     }
 */

    #[Route('/nombreGasto', name: 'nombre-nuevo-gasto')]
    public function nombreGasto(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {

        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {

                $em = $doctrine->getManager();

                $nombreGastos = $request->get('descripcionGasto');

                $nombreGasto = new CatalogoGastos();
                $nombreGasto->setDescripcion($nombreGastos);

                $em->persist($nombreGasto);
                $em->flush();


                return $this->render('Gastos/respuesta-alta-gasto.html.twig');

            } else { //es GET
                $em = $doctrine->getManager();
                return $this->render('Gastos/contenedor-nombre-gasto.html.twig');

            }


        }
    }

    #[Route('exportarGastos', name: 'exportarGastos')]
    public function exportarGastos(Request $request, ManagerRegistry $doctrine, Exportador $excelExporter, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {

            } else {


                $em = $doctrine->getManager();

                $fecha = $request->get('Fecha');
                $primer_Dia = $fecha;
                $Ultimo_dia = new \DateTime($primer_Dia);
                $Ultimo_dia->modify('Last day of this month');
                $dqlT = "SELECT "
                    . "g  "
                    . "FROM App\Entity\Gastos g "
                    . "WHERE "
                    . "g.fecMovGast "
                    . "BETWEEN "
                    . "'" . $primer_Dia . "'"
                    . " AND  "
                    . "'" . $Ultimo_dia->format('Y/m/d') . "'";

                $query = $entityManager->createQuery($dqlT);
                $gastos = $query->getResult();
                //$gastos = $em->getRepository(Gastos::class)->findAll();

                $spreadsheet = new Spreadsheet();

                $sheet = $spreadsheet->getActiveSheet();
                $sheet->mergeCells('A1:E1'); // Fusiona las celdas para el título
                $sheet->setCellValue('A1', 'Reporte de Gastos'); // Título del reporte
                $sheet->getStyle('A1')->getFont()->setBold(true)->setSize(16); // Formato del título
                $sheet->getStyle('A1')->getAlignment()->setHorizontal(Alignment::HORIZONTAL_CENTER); // Alineación del título

                $headers = ['#', 'NOMBRE', 'TOTAL', 'FECHA', 'TIPO DE PAGO'];
                $columnIndex = 1;

                foreach ($headers as $k => $header) {
                    $sheet->setCellValueByColumnAndRow($columnIndex, 2, $header); // Fila 2 para los encabezados de las columnas
                    $sheet->getStyleByColumnAndRow($columnIndex, 2)->getFont()->setBold(true);
                    $sheet->getColumnDimensionByColumn($columnIndex)->setAutoSize(true);
                    $columnIndex++;
                }

                $rowIndex = 3;
                foreach ($gastos as $k => $g) {
                    $columnIndex = 1;
                    $rowData = [
                        $k + 1,
                        $g->getCveCatGast() !== null ? $g->getCveCatGast()->getDescripcion() : 'N/A',
                        "$" . $g->getTotMon(),
                        $g->getFecMovGast()->format('Y-m-d'),
                        $g->getCveTipoPago() !== null ? $g->getCveTipoPago()->getModoPago() : 'N/A'
                        /*
                        ($g->getCveCatGast() != null) ? $g->getCveCatGast()->getDescripcion() : '', // Si es null, asigna una cadena vacía
                        '$' . number_format($g->getTotMon(), 2, ',', '.'),
                        $g->getFecMov()->format('Y-m-d'),
                        // $g->getIdeGast()*/
                    ];

                    foreach ($rowData as $value) {
                        $sheet->setCellValueByColumnAndRow($columnIndex, $rowIndex, $value);
                        $columnIndex++;
                    }

                    $rowIndex++;
                }

                $filename = 'exported_data.xlsx';

                $publicDirectory = $this->getParameter('kernel.project_dir') . '/public';

                $filePath = $publicDirectory . '/' . $filename;

                $writer = new Xlsx($spreadsheet);
                $writer->save($filePath);

                return $this->file($filePath, $filename);
            }

        }


    }


}





