<?php

namespace App\Controller;

use App\Entity\ArticulosInventario;
use App\Entity\CatalogoLugarInventario;
use App\Entity\CategoriaInventario;
use App\Entity\Ingresos;
use App\Entity\Inventario;
use App\Entity\Gastos;
use App\Entity\CatalogoGastos;
use App\Entity\MovimientosInventario;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

date_default_timezone_set('America/Mexico_City');

class InventarioController extends AbstractController
{
    #[Route('/inventario', name: 'inventario')]
    public function inventario(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $articulo = $request->get('articulo');
                $cantidad = $request->get('cantidad');
                $articulo = $em->getRepository(articulosInventario::class)
                    ->findOneBy(['ideArtInv' => $articulo]);

                $cveLugar = $request->get('lugar');
                $lugar = $em->getRepository(CatalogoLugarInventario::class)
                    ->findOneBy(['ideLugar' => $cveLugar]);

                $regInventario = new Inventario();

                $regInventario->setCveArticulo($articulo);
                $regInventario->setStock($cantidad);
                $regInventario->setCveLugarInventario($lugar);

                $em->persist($regInventario);
                $em->flush();

                $inventario = $em->getRepository(Inventario::class)->findAll();
                $opc = 1;

                // mandar a llamar solo art del mes//
                return $this->render('Inventarios/inventarios_tabla.html.twig', ['Inventario' => $inventario, 'Opcion' => $opc]);
            } else { //es GET

                $em = $doctrine->getManager();
                // $inventario = $em->getRepository(Inventario::class)->findAll();


                $dql = "SELECT i "
                    . "FROM App\Entity\Inventario i , App\Entity\ArticulosInventario a "
                    . "WHERE i.cveArticulo = a.ideArtInv "
                    . "ORDER BY a.nomArticulo ASC";

                $query = $entityManager->createQuery($dql);
                $inventario = $query->getResult(); // FORMULARIO DOS


                // SELECT nom_articulo FROM `articulos_inventario`
                $dql = "SELECT a "
                    . " FROM App\Entity\ArticulosInventario a "
                    . " WHERE a.ideArtInv NOT IN( "
                    . " SELECT DISTINCT(i.cveArticulo) "
                    . " FROM App\Entity\Inventario i)"
                    . " ORDER BY a.nomArticulo ASC";

                $query = $entityManager->createQuery($dql);
                $articulosInventarioUno = $query->getResult(); // FORMULARIO UNO


                $dql = "SELECT a "
                    . " FROM App\Entity\ArticulosInventario a "
                    . " WHERE a.ideArtInv IN( "
                    . " SELECT DISTINCT(i.cveArticulo) "
                    . " FROM App\Entity\Inventario i)"
                    . " ORDER BY a.nomArticulo ASC";

                $query = $entityManager->createQuery($dql);
                $articulosInventarioDos = $query->getResult(); // FORMULARIO DOS

                $catalogoInventario = $em->getRepository(CategoriaInventario::class)->findAll();

                $lugarInventario = $em->getRepository(CatalogoLugarInventario::class)->findAll();


                return $this->render('Inventarios/inventarios_form.html.twig',
                    [
                        'Inventario' => $inventario,
                        'ArticulosInventarioUno' => $articulosInventarioUno,
                        'ArticulosInventarioDos' => $articulosInventarioDos,
                        'categoria' => $catalogoInventario,
                        'lugar' => $lugarInventario
                    ]
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirInventario', name: 'imprimirInventario')]
    public function imprimirInventario(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET

                $em = $doctrine->getManager();


                $dql = "SELECT i "
                    . "FROM App\Entity\Inventario i , App\Entity\ArticulosInventario a "
                    . "WHERE i.cveArticulo = a.ideArtInv "
                    . "ORDER BY a.nomArticulo ASC";


                $query = $entityManager->createQuery($dql);
                $articulosInventarioU = $query->getResult(); // FORMULARIO DOS


                $pdf = new PdfInventario('P', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->Inventario($articulosInventarioU);
                return new Response(
                    $pdf->Output('articulosinventario_' . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/movimientosInventario', name: 'movimientosInventario')]
    public function movimientosInventario(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $art = $request->get('art');
                $cant = $request->get('cant');
                $observaciones = $request->get('observaciones');

                $opc = $request->get('opc');

                $art = $em->getRepository(Inventario::class)
                    ->findOneBy(['cveArticulo' => $art]);

                switch ($opc) {
                    case 1://agregar

                        $movimiento = 1;

                        if ($art != null) {
                            $art->setStock($art->getStock() + $cant);
                        } else {
                            $opc = 4;
                        }
                        break;

                    case 2://quitar
                        $movimiento = 0;
                        if ($art != null) {
                            if ($art->getStock() < $cant) {
                                $opc = 3;
                            } else {
                                $art->setStock($art->getStock() - $cant);
                            }
                        } else {
                            $opc = 4;
                        }
                        break;
                }
                $em->Flush();

                if ($opc != 3 & $opc != 4) {
                    $movinventario = new Invent();
                    $movinventario->setCveInventario($art);
                    $movinventario->setCantidad($cant);
                    $movinventario->setObservaciones($observaciones);
                    $movinventario->setTipoMovimiento($movimiento);// 0: quitar, 1: agregar
                    $movinventario->setFecMovimiento(new \DateTime(date('Y-m-d')));
                    $movinventario->SetHorMovimiento(new \DateTime(date('H:i:s')));

                    $em->persist($movinventario);
                    $em->Flush();
                }
                $inventario = $em->getRepository(Inventario::class)->findAll();

                // mandar a llamar solo art del mes//
                return $this->render('Inventarios/inventarios_tabla.html.twig', ['Inventario' => $inventario, 'Opcion' => $opc]);
            } else { //es GET
                $em = $doctrine->getManager();
                $minventario = $em->getRepository(Inventario::class)->findAll();

                return $this->render('Inventarios/inventarios_tabla.html.twig', ['Inventario' => $minventario]);
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirMovInventario', name: 'imprimirMovInventario')]
    public function imprimirMovInventario(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();
                //$articulos = $em->getRepository(MovimientosInventario::class)->findAll();

                //   $sql = "SELECT *FROM movimientos_inventario mi, inventario i, articulos_inventario ai WHERE mi.cve_inventario = ai.ide_art_inv GROUP BY ai.nom_articulo ASC;";


                $sql = "SELECT "
                    . "FROM movimientos_inventario mi, inventario i, articulos_inventario ai"
                    . " WHERE mi.cve_inventario = ai.ide_art_inv"
                    . " GROUP BY ai.nom_articulo ASC";

                $dql = "SELECT mi "
                    . "FROM App\Entity\MovimientosInventario mi , App\Entity\Inventario i , App\Entity\ArticulosInventario ai "
                    . "WHERE mi.cveInventario = ai.ideArtInv "
                    . "ORDER BY ai.nomArticulo ASC ";
                $query = $entityManager->createQuery($dql);
                $articulos = $query->getResult(); // FORMULARIO DOS


                $pdf = new PdfInventario('P', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->MovimientosInventario($articulos);
                return new Response(
                    $pdf->Output('inventario_' . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/registroArt', name: 'registroArt')]
    public function registroArt(Request $request, ManagerRegistry $doctrine): Response
    {

        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {

                $em = $doctrine->getManager();

                $NomArt = $request->get('NomArt');
                $categoria = $request->get('categoriaInventario');

                $categoriaInventario = $em->getRepository(CategoriaInventario::class)->findOneBy(['ideCategoriaInventario' => $categoria]);

                $arti = new ArticulosInventario();
                $arti->setNomArticulo($NomArt);
                $arti->setCveCategoria($categoriaInventario);

                $em->persist($arti);
                $em->flush();

                return $this->render('Inventarios/respuesta_alta-inv.html.twig');

            } else { //es GET
                $em = $doctrine->getManager();

                return $this->redirect($this->generateUrl('login'));
            }
        }
    }

    #[Route('/inventarioGeneral', name: 'inventarioGeneral')]
    public function inventarioGeneral(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'GET') { //es GET

                $em = $doctrine->getManager();

                $fecha = new \DateTime();

                $primerDia = $fecha->modify('first day of this month')->format('Y/m/d');
                $ultimoDia = $fecha->modify('last day of this month')->format('Y/m/d');


                /*  SELECT
                      i.fec_mov AS FECHA_INGRESO,
                      i.total AS TOTAL_INGRESO,
                      g.fec_mov AS FECHA_GASTO,
                      g.tot_mon AS TOTAL_GASTO
                      FROM ingresos i, gastos g
                      WHERE i.fec_mov BETWEEN '2023-05-01' AND '2023-05-30'
                                      AND g.fec_mov BETWEEN '2023-05-01' AND '2023-05-30'
                      ORDER BY i.fec_mov ASC;

                $dql = "SELECT "
                    . "i.fecMov FECHA_INGRESO, "
                    . "i.total TOTAL_INGRESO, "
                    . "g.fecMovGast FECHA_GASTO, "
                    . "g.totMon TOTAL_GASTO "
                    . "FROM App\Entity\Ingresos i, App\Entity\Gastos g "
                    . "WHERE i.fecMov BETWEEN "
                    . "'" . $primerDia . "'"
                    . " AND "
                    . "'" . $ultimoDia . "'"
                    . "AND g.fecMov BETWEEN "
                    . "'" . $primerDia . "'"
                    . " AND "
                    . "'" . $ultimoDia . "'"
                    . "ORDER BY i.fecMov ASC ";*/

                //SELECT i.fec_mov
                // AS FECHA,
                // SUM(i.total) AS TOTAL_INGRESO
                // FROM ingresos i
                // WHERE i.fec_mov
                // BETWEEN '2023-03-01'AND '2023-03-31'
                // GROUP BY i.fec_mov ORDER BY `FECHA` DESC;
                /*
                                $dql = "SELECT "
                                    . "i.fecMov FECHA,"
                                    . "SUM(i.total) TOTAL_INGRESOS,"
                                    . "COUNT(i.total) TOTALES,"
                                    . "(SELECT SUM(g.totMon) FROM App\Entity\Gastos g WHERE g.fecMov = i.fecMov) TOTAL_GASTOS "
                                    . "FROM App\Entity\Ingresos i "
                                    . "WHERE i.fecMov "
                                    . "BETWEEN "
                                    . "' " . $primerDia . " ' "
                                    . "AND"
                                    . "' " . $ultimoDia . "'"
                                    . "GROUP BY "
                                    . "i.fecMov";*/
                /*
                                $dql = "SELECT "
                                    . "COUNT(s.ideSer) SERVICIOS, "
                                    . "s.fecMov FECHA_SERVICIO, "
                                    . "SUM(sc.total) TOTAL_SERVICIO_CUENTA, "
                                    . "SUM(i.total) TOTAL_INGRESO, "
                                    . "i.fecMov FECHA_INGRESO "
                                    . "FROM App\Entity\Servicios s, App\Entity\ServiciosCuenta sc, App\Entity\Ingresos i, App\Entity\ServiciosMenu sm, App\Entity\Menus m "
                                    . "WHERE "
                                    . "sc.cveSer = s.ideSer "
                                    . "AND "
                                    . "i.cveSerCue = sc.ideSerCue "
                                    . "AND "
                                    . "s.ideSer = sm.cveSer "
                                    . "AND "
                                    . "sm.cveMen = m.ideMen "
                                    . "AND "
                                    . "sm.cveMen IN(SELECT men.ideMen FROM App\Entity\Menus men WHERE men.cveCatMen IN(1) ) "
                                    . "AND s.fecMov "
                                    . "BETWEEN "
                                    . "'" . $primerDia . "' "
                                    . "AND "
                                    . "'" . $ultimoDia . "' "
                                    . "AND i.fecMov "
                                    . "BETWEEN "
                                    . "'" . $primerDia . "' "
                                    . "AND "
                                    . "'" . $ultimoDia . "' "
                                    . "GROUP BY s.fecMov, i.fecMov";*/
                /*

                $dql = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "COUNT(s.ideSer) SERVICIOS, "
                    . "SUM(sc.total) TOTAL_SERVICIO_CUENTA,"
                    . "i.fecMov FECHA_INGRESO, "
                    . "COUNT(i.total) TOTALES_INGRESO, "
                    . "SUM(i.total) TOTAL_INGRESO, "
                    . "(SELECT SUM(g.totMon) FROM App\Entity\Gastos g WHERE g.fecMovGast = i.fecMov) TOTAL_GASTOS "
                    . "FROM App\Entity\Ingresos i, App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\ServiciosMenu sm, App\Entity\Menus m "
                    . "WHERE "
                    . "sc.cveSer = s.ideSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "s.ideSer = sm.cveSer "
                    . "AND "
                    . "sm.cveMen = m.ideMen "
                    . "AND "
                    . "sm . cveMen IN(SELECT men.ideMen FROM App\Entity\Menus men WHERE men.cveCatMen IN(1) ) "
                    . "AND "
                    . "s.fecMov "
                    . "BETWEEN "
                    . "'" . $primerDia . "' "
                    . "AND "
                    . "'" . $ultimoDia . "' "
                    . "AND "
                    . "i.fecMov "
                    . "BETWEEN "
                    . "' " . $primerDia . "' "
                    . "AND "
                    . "' " . $ultimoDia . "' "
                    . "GROUP BY "
                    . "i.fecMov";


                 * SELECT
                servicios.fec_mov,
                COUNT(servicios.ide_ser) AS TICKETS,
                SUM(servicios_cuenta.total) AS total_esperado,
                ingresos.fec_mov, SUM(ingresos.total) as ingresos_total,
                (SELECT SUM(g.tot_mon) FROM gastos g WHERE g.fec_mov_gast = ingresos.fec_mov) AS TOTAL_GASTOS
                FROM
                servicios_cuenta,servicios,ingresos
                WHERE
                servicios.ide_ser = servicios_cuenta.cve_ser
                AND
                ingresos.cve_ser_cue = servicios_cuenta.ide_ser_cue
                AND
                ingresos.fec_mov = servicios.fec_mov
                AND
                servicios_cuenta.cve_ser IN(SELECT servicios.ide_ser FROM servicios WHERE servicios.fec_mov BETWEEN '2023-05-01' AND '2023-05-30') GROUP BY servicios.fec_mov;
                 * */

                $dql = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "COUNT(s.ideSer) N_TICKET, "
                    . "SUM(sc.total) TOTAL_ESPERADO, "
                    . "i.fecMov FECHA_INGRESO, "
                    . "SUM(i.total) TOTAL_INGRESOS, "
                    . "( SELECT SUM(g.totMon) FROM App\Entity\Gastos g WHERE g.fecMovGast = i.fecMov "
                    . "AND g.cveTipoPago IN (SELECT mp.ideModPag FROM App\Entity\ModoPagos mp "
                    . "WHERE g.cveTipoPago IN (1) ) ) TOTAL_GASTOS "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(1) ) "
                    . "AND "
                    . "s.ideSer = sc.cveSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "i.fecMov = s.fecMov "
                    . "AND "
                    . "sc.cveSer IN (SELECT ser.ideSer FROM App\Entity\Servicios ser WHERE ser.fecMov BETWEEN '$primerDia' AND '$ultimoDia') "
                    . "GROUP BY s.fecMov";


                $query = $entityManager->createQuery($dql);
                $resumenGastos = $query->getResult();

                return $this->render('Inventarios/inventario_general.html.twig',
                    [
                        'ingresos' => $resumenGastos,
                    ]
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCorteGeneralDias', name: 'imprimir_corte_general_dia_es')]
    public function imprimirCorteGeneralDias(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $Dia = $request->get('Fecha');
                if ($Dia == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = $Dia;
                }
                /*
                $dql = "SELECT "
                    . "i . fecMov FECHA, "
                    . "SUM(i . total) TOTAL_INGRESOS, "
                    . "COUNT(i . total) TOTALES "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE i . fecMov = "
                    . "' " . $hoy . "'"
                    . "GROUP BY i . fecMov ";
                $query = $entityManager->createQuery($dql);
                $resumenGastosDD = $query->getResult(); // FORMULARIO DOS

                $dql3 = "SELECT "
                    . "i . fecMov FECHA_INGRESOS, "
                    . "i . total TOTAL_INGRESOS, "
                    . "g . fecMov FECHA_GASTOS, "
                    . "g . totMon TOTAL_GASTOS "
                    . "FROM App\Entity\Ingresos i , App\Entity\Gastos g "
                    . "WHERE i . fecMov = "
                    . "' " . $hoy . "'"
                    . " and g . fecMov = "
                    . "' " . $hoy . "'";
                $query = $entityManager->createQuery($dql3);
                $ingresos = $query->getResult();

                $dql = "SELECT "
                    . "COUNT(s . ideSer) SERVICIOS, "
                    . "s . fecMov FECHA_SERVICIO, "
                    . "SUM(sc . total) TOTAL_SERVICIO_CUENTA, "
                    . "SUM(i . total) TOTAL_INGRESO, "
                    . "i . fecMov FECHA_INGRESO "
                    . "FROM App\Entity\Servicios s, App\Entity\ServiciosCuenta sc, App\Entity\Ingresos i, App\Entity\ServiciosMenu sm, App\Entity\Menus m "
                    . "WHERE "
                    . "sc . cveSer = s . ideSer "
                    . " and "
                    . "i . cveSerCue = sc . ideSerCue "
                    . " and "
                    . "s . ideSer = sm . cveSer "
                    . " and "
                    . "sm . cveMen = m . ideMen "
                    . " and "
                    . "sm . cveMen IN(SELECT men . ideMen FROM App\Entity\Menus men WHERE men . cveCatMen IN(1) ) "
                    . " and s . fecMov = "
                    . "'" . $hoy . "' "
                    . " and i . fecMov = "
                    . "'" . $hoy . "' "
                    . "GROUP BY s . fecMov, i . fecMov";
*/

                /*
                 * SELECT
                s.ide_ser AS IDE_SERVICIO,
                s.fec_mov AS FECHA_SERVICIO,
                s.hor_mov AS HORA_SERVICIO,
                sc.total AS TOTAL_SERVICIO,
                i.fec_mov AS FECHA_INGRESO,
                i.hor_mov AS HORA_INGRESO,
                i.total AS TOTAL_INGRESO
                FROM servicios_cuenta sc, servicios s, ingresos i
                WHERE
                sc.cve_ser = s.ide_ser
                AND
                i.cve_ser_cue = sc.ide_ser_cue
                AND
                s.fec_mov = '2023-03-03'
                AND
                i.fec_mov = '2023-03-03';*/

                $dql = "SELECT "
                    . "s . ideSer IDE_SERVICIO, "
                    . "i . fecMov FECHA_INGRESO, "
                    . "i.horMov HORA_MOV, "
                    . "i . total TOTAL_INGRESO "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(1) ) "
                    . "AND "
                    . "sc . cveSer = s . ideSer "
                    . " and "
                    . "i . cveSerCue = sc . ideSerCue "
                    . " and s . fecMov = "
                    . "'" . $hoy . "' "
                    . " and i . fecMov = "
                    . "'" . $hoy . "' ";

                $query = $entityManager->createQuery($dql);
                $corteResumenDia = $query->getResult();
                /* SELECT
                 g.fec_mov_gast AS FECHA_MOV,
                 g.hor_mov_gast AS HORA_MOV,
                 g.tot_mon AS TOTAL_GASTO
                 FROM gastos g
                 WHERE
                 g.fec_mov_gast =
                     '2023-04-01';*/

                $dql2 = "SELECT "
                    . "g . fecMovGast FECHA_GASTO, "
                    . "g . totMon TOTAL_GASTO, "
                    . "cg.descripcion NOMBRE "
                    . "FROM App\Entity\Gastos g, App\Entity\CatalogoGastos cg "
                    . "WHERE "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(1) ) "
                    . "AND g . fecMovGast = "
                    . "'" . $hoy . "' "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast ";

                $query = $entityManager->createQuery($dql2);
                $gastosDia = $query->getResult();


                $pdf = new PdfReportes('P', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->imprimirCorteGeneraDia($corteResumenDia, $hoy, $gastosDia);


                return new Response(
                    $pdf->Output('Reporte_Gast_Ingresos_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }


    #[Route('/imprimirCorteGeneralMes', name: 'imprimir_corte_corte_PDF_Mes')]
    public function imprimirCorteGeneralMes(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $fechaGeneral = $request->get('reporteGM');

                $primerDia = $fechaGeneral . "-01";
                $fechaFin = new \DateTime($primerDia);
                $fechaFin->modify('Last day of this month');

                /*
                                $dql = "SELECT "
                                    . "i . fecMov FECHA, "
                                    . "SUM(i . total) TOTAL_INGRESOS, "
                                    . "COUNT(i . total) TOTALES "
                                    . "FROM App\Entity\Ingresos i "
                                    . "WHERE i . fecMov  "
                                    . "BETWEEN "
                                    . "' " . $primerDia . "' "
                                    . " and "
                                    . "' " . $fechaFin->format('Y - m - d') . "' "
                                    . "GROUP BY i . fecMov "
                                    . "ORDER BY i . fecMov ASC";
                                $query = $entityManager->createQuery($dql);
                                $resumenGastosDD = $query->getResult(); // FORMULARIO DOS*/
                /*SELECT
                i.fec_mov AS FECHA,
                i.total AS TOTAL_PROD
                FROM ingresos i
                WHERE i.fec_mov
                BETWEEN
                '2023-04-01'
                AND
                '2023-04-30';*/
                /*
                $dql3 = "SELECT "
                    . "i . fecMov FECHA_INGRESOS, "
                    . "i . total TOTAL_INGRESOS, "
                    . "g . fecMov FECHA_GASTOS, "
                    . "g . totMon TOTAL_GASTOS "
                    . "FROM App\Entity\Ingresos i , App\Entity\Gastos g "
                    . "WHERE i . fecMov "
                    . "BETWEEN "
                    . "'" . $primerDia . "' "
                    . " and "
                    . "'" . $fechaFin->format('Y - m - d') . "' "
                    . " and g . fecMov "
                    . "BETWEEN "
                    . "'" . $primerDia . "' "
                    . " and "
                    . "'" . $fechaFin->format('Y - m - d') . "'";

                $query = $entityManager->createQuery($dql3);
                $ingresos = $query->getResult();

                */

                $dql = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "COUNT(s.ideSer) N_TICKET, "
                    . "SUM(sc.total) TOTAL_ESPERADO, "
                    . "i.fecMov FECHA_INGRESO, "
                    . "SUM(i.total) TOTAL_INGRESOS, "
                    . "( SELECT
                        SUM(g.totMon) 
                        FROM App\Entity\Gastos g 
                        WHERE g.fecMovGast = i.fecMov "
                    . "AND g.cveTipoPago IN (SELECT mp.ideModPag FROM App\Entity\ModoPagos mp "
                    . "WHERE g.cveTipoPago IN (1) ) ) TOTAL_GASTOS "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(1) ) "
                    . "AND "
                    . "s.ideSer = sc.cveSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "i.fecMov = s.fecMov "
                    . "AND "
                    . "sc.cveSer IN (SELECT ser.ideSer FROM App\Entity\Servicios ser WHERE ser.fecMov BETWEEN '$primerDia' AND '" . $fechaFin->format('Y-m-d') . "') "
                    . "GROUP BY s.fecMov";

                $query = $entityManager->createQuery($dql);
                $reporteGeneralMes = $query->getResult();


                $dql = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "COUNT(s.ideSer) N_TICKET, "
                    . "SUM(sc.total) TOTAL_ESPERADO, "
                    . "i.fecMov FECHA_INGRESO, "
                    . "SUM(i.total) TOTAL_INGRESOS, "
                    . "( SELECT
                        SUM(g.totMon) 
                        FROM App\Entity\Gastos g 
                        WHERE g.fecMovGast = i.fecMov "
                    . "AND g.cveTipoPago IN (SELECT mp.ideModPag FROM App\Entity\ModoPagos mp "
                    . "WHERE g.cveTipoPago IN (2) ) ) TOTAL_GASTOS "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(2) ) "
                    . "AND "
                    . "s.ideSer = sc.cveSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "i.fecMov = s.fecMov "
                    . "AND "
                    . "sc.cveSer IN (SELECT ser.ideSer FROM App\Entity\Servicios ser WHERE ser.fecMov BETWEEN '$primerDia' AND '" . $fechaFin->format('Y-m-d') . "') "
                    . "GROUP BY s.fecMov";

                $query = $entityManager->createQuery($dql);
                $reporteGeneralMesT = $query->getResult();


                $pdf = new PdfNotas('L', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(0);
                $pdf->imprimirCorteGeneralMes($reporteGeneralMes, $fechaGeneral, $reporteGeneralMesT);

                return new Response(
                    $pdf->Output('reporte_mes' . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }


    #[Route('/imprimirCorteGeneral', name: 'imprimir_corte_corte_PDF')]
    public function imprimirCorteGeneral(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $Dia = $request->get('Fecha');
                if ($Dia == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = $Dia;
                }


                /*
                 * $dql = "SELECT "
                    . "i . fecMov FECHA, "
                    . "SUM(i . total) TOTAL_INGRESOS, "
                    . "COUNT(i . total) TOTALES "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE i . fecMov = "
                    . "' " . $hoy . "'"
                    . "GROUP BY i . fecMov "
                    . "ORDER BY i . fecMov ASC";
                $query = $entityManager->createQuery($dql);
                $resumenGastosDD = $query->getResult(); // FORMULARIO DOS
                 * SELECT
                i.fec_mov AS FECHA,
                i.total AS TOTAL_PROD
                FROM ingresos i
                WHERE i.fec_mov
                BETWEEN
                '2023-04-01'
                AND
                '2023-04-30';

                $dql3 = "SELECT "
                    . "i . fecMov FECHA_INGRESOS, "
                    . "i . total TOTAL_INGRESOS, "
                    . "g . fecMov FECHA_GASTOS, "
                    . "g . totMon TOTAL_GASTOS "
                    . "FROM App\Entity\Ingresos i , App\Entity\Gastos g "
                    . "WHERE i . fecMov = "
                    . "' " . $hoy . "'"
                    . " and g . fecMov = "
                    . "' " . $hoy . "'";
                */
                $dql = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "s.ideSer N_TICKET, "
                    . "sc.total TOTAL_ESPERADO, "
                    . "i.fecMov FECHA_INGRESO, "
                    . "i.total TOTAL_INGRESOS, "
                    . "i.horMov HORA_ING, "
                    . "(SELECT MAX(g.totMon) FROM App\Entity\Gastos g WHERE g.fecMovGast = i.fecMov) TOTAL_GASTOS "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(1) ) "
                    . "AND "
                    . "s.ideSer = sc.cveSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "i.fecMov = s.fecMov "
                    . "AND "
                    . "sc.cveSer IN (SELECT ser.ideSer FROM App\Entity\Servicios ser WHERE ser.fecMov = '$hoy') ";

                $query = $entityManager->createQuery($dql);
                $ingresos = $query->getResult();


                $dql2 = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "s.ideSer N_TICKET, "
                    . "sc.total TOTAL_ESPERADO, "
                    . "i.fecMov FECHA_INGRESO, "
                    . "i.total TOTAL_INGRESOS, "
                    . "i.horMov HORA_ING, "
                    . "(SELECT MAX(g.totMon) FROM App\Entity\Gastos g WHERE g.fecMovGast = i.fecMov) TOTAL_GASTOS "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(2) ) "
                    . "AND "
                    . "s.ideSer = sc.cveSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "i.fecMov = s.fecMov "
                    . "AND "
                    . "sc.cveSer IN (SELECT ser.ideSer FROM App\Entity\Servicios ser WHERE ser.fecMov = '$hoy') ";

                $query = $entityManager->createQuery($dql2);
                $ingresosE = $query->getResult();

                $dqlE = "SELECT "
                    . "cg.descripcion ARTICULO, "
                    . "g.totMon TOTAL, "
                    . "g.fecMovGast FECHA, "
                    . "g.horMov HORA "
                    . "FROM App\Entity\Gastos g, App\Entity\CatalogoGastos cg "
                    . "WHERE "
                    . "g.cveTipoPago IN (SELECT m.ideModPag FROM App\Entity\ModoPagos m WHERE g.cveTipoPago = 1) "
                    . "AND "
                    . "g.fecMov = '" . $hoy . "' "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast ";

                $query = $entityManager->createQuery($dqlE);
                $gastosE = $query->getResult();


                $dqlT = "SELECT "
                    . "cg.descripcion ARTICULO, "
                    . "g.totMon TOTAL, "
                    . "g.fecMovGast FECHA, "
                    . "g.horMov HORA "
                    . "FROM App\Entity\Gastos g, App\Entity\CatalogoGastos cg "
                    . "WHERE "
                    . "g.cveTipoPago IN (SELECT m.ideModPag FROM App\Entity\ModoPagos m WHERE g.cveTipoPago = 2) "
                    . "AND "
                    . "g.fecMov = '" . $hoy . "' "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast ";

                $query = $entityManager->createQuery($dqlT);
                $gastosT = $query->getResult();

                $pdf = new PdfReportes('P', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->imprimirCorteGeneral($hoy, $ingresos, $ingresosE, $gastosE, $gastosT);

                return new Response(
                    $pdf->Output('ingresos_' . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/lugarInventario', name: 'lugar-inventario')]
    public function lugarInventario(Request $request, ManagerRegistry $doctrine): Response
    {

        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {

                $em = $doctrine->getManager();

                $lugar = $request->get('lugarInventario');

                $lugarInv = new CatalogoLugarInventario();
                $lugarInv->setDescripcion($lugar);
                $em->persist($lugarInv);
                $em->flush();
                //return $this->render('Inventarios/contenedor-lugar-inventario.html.twig');
                return $this->redirect($this->generateUrl('inventario'));

            } else { //es GET
                $em = $doctrine->getManager();

                return $this->render('Inventarios/contenedor-lugar-inventario.html.twig');

            }
        }
    }

    #[Route('/agregarCategoria', name: 'inventario-categoria')]
    public function agregarCategoria(Request $request, ManagerRegistry $doctrine): Response
    {

        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {

                $em = $doctrine->getManager();

                $categoria = $request->get('nomCategoria');

                $nuevaCategoria = new CategoriaInventario();
                $nuevaCategoria->setDescripcion($categoria);
                $em->persist($nuevaCategoria);
                $em->flush();
                return $this->redirect($this->generateUrl('inventario'));

            } else { //es GET
                $em = $doctrine->getManager();

                return $this->render('Inventarios/contenedor-categoria.html.twig');

            }
        }
    }

    /*
        #[Route('/gastosingresos', name: 'imprimir_ingresos_&_gastos')]
        public function gastosingresos(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
        {
            $session = $request->getSession();
            if ($session->has('ideUsuario')) {
                if ($request->getMethod() == 'POST') {
                    return $this->redirect($this->generateUrl('login'));
                } else { // ES GET
                    $em = $doctrine->getManager();

                    $Mes = $request->get('ingresosGastos');
                    $primer_Dia = $Mes . "-01";
                    $Ultimo_dia = new \DateTime($primer_Dia);
                    $Ultimo_dia->modify('Last day of this month');

                    $dql = "SELECT "
                        . "SUM(i.total) TOTAL, "
                        . "i.fecMov FECHA "
                        . "FROM App\Entity\Ingresos i "
                        . "WHERE "
                        . "i.fecMov "
                        . "BETWEEN "
                        . "' " . $primer_Dia . "' "
                        . "AND "
                        . "' " . $Ultimo_dia->format('Y-m-d') . "' "
                        . "AND "
                        . "i . cveModPag IN(SELECT m . ideModPag FROM App\Entity\ModoPagos m WHERE i . cveModPag IN(1)) "
                        . "GROUP BY "
                        . "i . fecMov "
                        . "ORDER BY "
                        . "i.fecMov";

                    $query = $entityManager->createQuery($dql);
                    $i = $query->getResult();

                    $dqli = "SELECT "
                        . "SUM(i.total) TOTAL, "
                        . "i.fecMov FECHA "
                        . "FROM App\Entity\Ingresos i "
                        . "WHERE "
                        . "i.fecMov "
                        . "BETWEEN "
                        . "' " . $primer_Dia . "' "
                        . "AND "
                        . "' " . $Ultimo_dia->format('Y-m-d') . "' "
                        . "AND "
                        . "i . cveModPag IN(SELECT m . ideModPag FROM App\Entity\ModoPagos m WHERE i . cveModPag IN(2)) "
                        . "GROUP BY "
                        . "i . fecMov "
                        . "ORDER BY "
                        . "i.fecMov";

                    $query = $entityManager->createQuery($dqli);
                    $i2 = $query->getResult();

                    $dqlR = "SELECT "
                        . "cg.descripcion DESCRIPCION, "
                        . "SUM(g.totMon) SUMA, "
                        . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                        . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                        . "WHERE "
                        . "g.cveCatGast = cg.ideCatGast "
                        . "AND "
                        . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(1) ) "
                        . "AND g.fecMovGast "
                        . "BETWEEN "
                        . "' " . $primer_Dia . "' "
                        . "AND"
                        . "' " . $Ultimo_dia->format('Y-m-d') . "' "
                        . "GROUP BY cg.descripcion "
                        . "ORDER BY cg.descripcion ASC";

                    $query = $entityManager->createQuery($dqlR);
                    $g = $query->getResult();

                    $dqlT = "SELECT "
                        . "cg.descripcion DESCRIPCION, "
                        . "SUM(g.totMon) SUMA, "
                        . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                        . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                        . "WHERE "
                        . "g.cveCatGast = cg.ideCatGast "
                        . "AND "
                        . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(2) ) "
                        . "AND g.fecMovGast "
                        . "BETWEEN "
                        . "' " . $primer_Dia . "' "
                        . "AND"
                        . "' " . $Ultimo_dia->format('Y-m-d') . "' "
                        . "GROUP BY cg.descripcion "
                        . "ORDER BY cg.descripcion ASC";

                    $query = $entityManager->createQuery($dqlT);
                    $gT = $query->getResult();


                    $pdf = new PdfNotas('L', 'mm', 'letter');
                    $pdf->SetFont('Helvetica', '', 8);
                    $pdf->AddPage();
                    $pdf->SetLeftMargin(5);
                    $pdf->SetRightMargin(5);
                    $pdf->ingresosGastos($g, $i, $i2, $gT, $Mes);
                    return new Response(
                        $pdf->Output('gastosMes_' . $Mes . '.pdf', 'I'),
                        200,
                        array('Content-Type' => 'application/pdf')
                    );

                }
            } else {
                return $this->redirect($this->generateUrl('login'));
            }
        }
    */

    #[Route('/gastosingresos', name: 'imprimir_ingresos_&_gastos')]
    public function gastosingresos(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $fechaGeneral = $request->get('ingresosGastos');

                $primerDia = $fechaGeneral . "-01";
                $fechaFin = new \DateTime($primerDia);
                $fechaFin->modify('Last day of this month');

                $dqlR = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(1) ) "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMovGast "
                    . "BETWEEN "
                    . "'" . $primerDia . "'"
                    . " AND  "
                    . "'" . $fechaFin->format('Y/m/d') . "'"
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlR);
                $resumenG = $query->getResult();

                $dql = "SELECT "
                    . "s.fecMov FECHA_SERVICIO, "
                    . "COUNT(s.ideSer) N_TICKET, "
                    . "SUM(sc.total) TOTAL_ESPERADO, "
                    . "i.fecMov FECHA_INGRESO, "
                    . "SUM(i.total) TOTAL_INGRESOS, "
                    . "( SELECT SUM(g.totMon) FROM App\Entity\Gastos g WHERE g.fecMovGast = i.fecMov "
                    . "AND g.cveTipoPago IN (SELECT mp.ideModPag FROM App\Entity\ModoPagos mp "
                    . "WHERE g.cveTipoPago IN (1) ) ) TOTAL_GASTOS "
                    . "FROM App\Entity\ServiciosCuenta sc, App\Entity\Servicios s, App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.cveModPag IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE i.cveModPag IN(1) ) "
                    . "AND "
                    . "s.ideSer = sc.cveSer "
                    . "AND "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "AND "
                    . "i.fecMov = s.fecMov "
                    . "AND "
                    . "sc.cveSer IN (SELECT ser.ideSer FROM App\Entity\Servicios ser WHERE ser.fecMov BETWEEN '$primerDia' AND '" . $fechaFin->format('Y-m-d') . "') "
                    . "GROUP BY s.fecMov";

                $query = $entityManager->createQuery($dql);
                $reporteGeneralMes = $query->getResult();


                $pdf = new PdfReportes('P', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->ingresosGastos($resumenG, $reporteGeneralMes);

                return new Response(
                    $pdf->Output('reporte_mes' . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }


}