<?php

namespace App\Controller;

use App\Entity\Contadores;
use App\Entity\Gastos;
use App\Entity\Ingresos;
use App\Entity\ModoPagos;
use App\Entity\Servicios;
use App\Entity\ServiciosCuenta;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Controller\PdfReportes;
use function Symfony\Component\DependencyInjection\Loader\Configurator\service;

date_default_timezone_set('America/Mexico_City');

class PagosController extends AbstractController
{
    #[Route('/buscarNota', name: 'buscar_nota')]
    public function buscarNota(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $ideServicio = $request->get('ideServicio');

                $servicio = $em->getRepository(Servicios::class)
                    ->findOneBy(
                        ['ideSer' => $ideServicio]
                    );

                $formasPago = $em->getRepository(ModoPagos::class)->findAll();

                $dql = "select " .
                    "IDENTITY(sm.cveSer) cveSer, IDENTITY(sm.cveMen) cveMen, m.nomMen, sm.precio, count(sm) total, SUM(sm.descuento) descuento, SUM(sm.subtotal) subtotal " .
                    "from App\Entity\ServiciosMenu sm, " .
                    "App\Entity\Menus m " .
                    "where " .
                    "m.ideMen = sm.cveMen " .
                    "and " .
                    "sm.cveSer = $ideServicio " .
                    "group by sm.cveMen";
                $query = $entityManager->createQuery($dql);
                $cuenta = $query->getResult();

                $servicioCuenta = $em->getRepository(ServiciosCuenta::class)
                    ->findOneBy(
                        ['cveSer' => $servicio]
                    );
                $ingreso = $em->getRepository(Ingresos::class)
                    ->findOneBy(['cveSerCue' => $servicioCuenta]);
                return $this->render('Pagos/respuesta-buscar-nota-detalles.html.twig',
                    [
                        'servicio' => $servicio,
                        'cuenta' => $cuenta,
                        'formasPago' => $formasPago,
                        'servicioCuenta' => $servicioCuenta,
                        'nota' => $ideServicio,
                        'ingreso' => $ingreso,
                        'ideSer' => $ideServicio
                    ]
                );
            } else { // ES GET
                return $this->redirect($this->generateUrl('login'));
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/listarNotas', name: 'listar_notas')]
    public function listarNotas(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                // $ideServicio = $request->get('ideSer');

                $serviciosTerminados = $em->getRepository(Servicios::class)
                    ->findBy(['estatus' => 0]);

                $serviciosCuenta = $em->getRepository(ServiciosCuenta::class)
                    ->findBy(['cveSer' => $serviciosTerminados]);

                $hoy = new \DateTime(date('Y-m-d'));

                // $hoy = '2023-03-01';


                $notasSinPago = [];
                $notasConPago = [];
                foreach ($serviciosCuenta as $sc) {

                    /* SELECT *
                     FROM ingresos i, servicios s
                     WHERE
                     i.fec_mov
                     BETWEEN
                     '2023-05-01'
                     AND
                     '2023-05-30'
                     AND
                     s.fec_mov
                     BETWEEN
                     '2023-05-01'
                     AND
                     '2023-05-30';*/

                    /*$dql = "SELECT i "
                        . "FROM App\Entity\Ingresos i, App\Entity\Servicios s "
                        . "WHERE "
                        . "i.cveSerCue = " . $sc->getIdeSerCue();

                    $query = $entityManager->createQuery($dql);
                    $auxIngreso = $query->getResult();*/

                    $auxIngreso = $em->getRepository(Ingresos::class)
                        ->findOneBy(['cveSerCue' => $sc->getIdeSerCue()]);

                    if ($auxIngreso == null) {
                        $notasSinPago[] = $sc;
                    } else {

                        if ($auxIngreso->isBanderaPropina() == 1) {
                            if ($auxIngreso->getFecMov() == $hoy) {
                                $notasConPago[] = [$sc, 1];
                            }
                        } else {
                            $notasConPago[] = [$sc, 0];
                        }
                    }
                }
                /*
                                print_r($notasSinPago);
                                die();
                                $servicios = $em->getRepository(Servicios::class)
                                    ->findOneBy(['ideSer' => $ideServicio]);

                                foreach ($servicios as $key => $s) {

                                }*/

                return $this->render('Pagos/lista-notas.html.twig',
                    [
                        'notasSinPago' => $notasSinPago,
                        'notasConPago' => $notasConPago,
                        'cancelar' => $serviciosTerminados
                    ]
                );
            } else { // ES GET
                return $this->redirect($this->generateUrl('login'));
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/registrarIngreso', name: 'registrar_ingreso')]
    public function registrarIngreso(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $ideServicio = $request->get('ideServicio');
                $totalAPagar = $request->get('totalAPagar');
                $formaPago = $request->get('formaPago');
                $pagoCon = $request->get('pagoCon');

                $servicio = $em->getRepository(Servicios::class)
                    ->findOneBy(
                        ['ideSer' => $ideServicio]
                    );
                $modoPago = $em->getRepository(ModoPagos::class)
                    ->findOneBy(['ideModPag' => $formaPago]);

                $servicioCuenta = $em->getRepository(ServiciosCuenta::class)
                    ->findOneBy(
                        ['cveSer' => $servicio]
                    );

                $ingreso = new Ingresos();
                $ingreso->setCveSerCue($servicioCuenta);
                $ingreso->setTotal($totalAPagar);
                $ingreso->setCveModPag($modoPago);
                $ingreso->setReferencia(null);
                $ingreso->setPagoCon($pagoCon);
                if ($formaPago == 1) {//EFECTIVO
                    $cambio = $pagoCon - $totalAPagar;
                    $ingreso->setCambio($cambio);
                } else {
                    $ingreso->setCambio(0);
                }
                $ingreso->setPropina(0);
                $ingreso->setCveModPagPropina(null);
                $ingreso->setBanderaPropina(0);


                $contador = $em->getRepository(Contadores::class)
                    ->findOneBy(['clave' => 'cont-ingresos']);

                if ($contador->getIndice() <= 9) {
                    $folioRecibo = date('ymd') . "00" . $contador->getIndice();
                } elseif ($contador->getIndice() <= 99) {
                    $folioRecibo = date('ymd') . "0" . $contador->getIndice();
                } else {
                    $folioRecibo = date('ymd') . $contador->getIndice();
                }

                $ingreso->setRecibo($folioRecibo);
                $ingreso->setFecMov(new \DateTime(date('Y-m-d')));
                $ingreso->setHorMov(new \DateTime(date('H:i:s')));
                $em->persist($ingreso);
                $em->flush();

                $contador->setIndice($contador->getIndice() + 1);
                $em->flush();


                return $this->render('Pagos/respuesta-recibo-ingreso.html.twig',
                    [
                        'ingreso' => $ingreso
                    ]
                );
            } else { // ES GET
                return $this->redirect($this->generateUrl('login'));
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirIngreso', name: 'imprimir_ingreso')]
    public function imprimirIngreso(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $ideIngreso = $request->get('ide');

                $ingreso = $em->getRepository(Ingresos::class)
                    ->findOneBy(['ideIng' => $ideIngreso]);

                $pdf = new PdfTicket('P', 'mm', array(48, 200));
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->reciboIngreso($ingreso);


                return new Response(
                    $pdf->Output('ingreso_' . $ideIngreso . '_' . $ingreso->getRecibo() . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCorteDelMes', name: 'imprimir_corte_Mes')]
    public function imprimirCorteDelMes(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $Mes = $request->get('Mes');
                $primer_Dia = $Mes . "-01";
                $Ultimo_dia = new \DateTime($primer_Dia);
                $Ultimo_dia->modify('Last day of this month');

                $dql = "SELECT "
                    . "i "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.fecMov "
                    . "BETWEEN "
                    . "'" . $primer_Dia . "'"
                    . " AND  "
                    . "'" . $Ultimo_dia->format('Y/m/d') . "'";

                $query = $entityManager->createQuery($dql);
                $resultados = $query->getResult();

                $pdf = new PdfNotas('L', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->reporteDelMes($resultados, $Mes);
                return new Response(
                    $pdf->Output('reporteDelMes_' . $primer_Dia . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCorte', name: 'imprimir_corte')]
    public function imprimirCorte(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $fecha = $request->get('fecha');

                if ($fecha == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = date($fecha);
                }

                $ingresos = $em->getRepository(Ingresos::class)
                    ->findBy(['fecMov' => new \DateTime($hoy)]);

                $pdf = new PdfTicket('P', 'mm', array(48, 200));
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->corteDiario($ingresos, $hoy);

                return new Response(
                    $pdf->Output('ingresos_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCortepdf', name: 'imprimir_corte_PDF')]
    public function imprimirCortepdf(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $fecha = $request->get('fecha');

                if ($fecha == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = date($fecha);
                }

                $ingresos = $em->getRepository(Ingresos::class)
                    ->findBy(['fecMov' => new \DateTime($hoy)]);

                $pdf = new PdfNotas('L', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->corteDiarioCta($ingresos, $hoy);

                return new Response(
                    $pdf->Output('ingresos_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }


    #[Route('/registrarPropina', name: 'registrar_propina')]
    public function registrarPropina(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $ideServicio = $request->get('ideServicio');
                $propina = $request->get('propina');
                $formaPago = $request->get('formaPago');

                $servicio = $em->getRepository(Servicios::class)
                    ->findOneBy(
                        ['ideSer' => $ideServicio]
                    );

                $modoPago = $em->getRepository(ModoPagos::class)
                    ->findOneBy(['ideModPag' => $formaPago]);

                $servicioCuenta = $em->getRepository(ServiciosCuenta::class)
                    ->findOneBy(
                        ['cveSer' => $servicio]
                    );

                $ingreso = $em->getRepository(Ingresos::class)
                    ->findOneBy(['cveSerCue' => $servicioCuenta]);
                if ($ingreso != null) {
                    $ingreso->setPropina($propina);
                    $ingreso->setCveModPagPropina($modoPago);
                    $ingreso->setBanderaPropina(1);
                    $em->flush();
                }

                return $this->render('Pagos/respuesta-recibo-propina.html.twig',
                    [
                        'ingreso' => $ingreso
                    ]
                );
            } else { // ES GET
                return $this->redirect($this->generateUrl('login'));
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirPropina', name: 'imprimir_propina')]
    public function imprimirPropina(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $ideIngreso = $request->get('ide');

                $ingreso = $em->getRepository(Ingresos::class)
                    ->findOneBy(['ideIng' => $ideIngreso]);

                $pdf = new PdfTicket('P', 'mm', array(48, 200));
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->reciboPropina($ingreso);

                return new Response(
                    $pdf->Output('propina_' . $ideIngreso . '_' . $ingreso->getRecibo() . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirGastos', name: 'imprimir_Gastos')]
    public function imprimirGasto(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $Dia = $request->get('Fecha');
                if ($Dia == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = $Dia;
                }


                $gastos = $em->getRepository(Gastos::class)
                    ->findBy(['fecMov' => new \DateTime($hoy)]);


                $dqlR = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(1) ) "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMov = "
                    . "' " . $hoy . "' "
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlR);
                $resumenG = $query->getResult();


                $dqlT = "SELECT "
                    . "cg.descripcion DESCRIPCION, "
                    . "SUM(g.totMon) SUMA, "
                    . "COUNT(cg.descripcion) COUNT_DESCRIPCION "
                    . "FROM App\Entity\CatalogoGastos cg, App\Entity\Gastos g "
                    . "WHERE "
                    . "g.cveTipoPago IN( SELECT p.ideModPag FROM App\Entity\ModoPagos p WHERE g.cveTipoPago IN(2) ) "
                    . "AND "
                    . "g.cveCatGast = cg.ideCatGast "
                    . "AND g.fecMov = "
                    . "' " . $hoy . "' "
                    . "GROUP BY cg.descripcion "
                    . "ORDER BY cg.descripcion ASC";
                $query = $entityManager->createQuery($dqlT);
                $resumenGT = $query->getResult();

                $pdf = new PdfReportes('P', 'mm', "letter");
                //$pdf->Image();
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->generarReportes($gastos, $hoy, $resumenG, $resumenGT);

                return new Response(
                    $pdf->Output('gasto_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    /*
        #[Route('/imprimirBuffet', name: 'imprimir_Buffet')]
        public function imprimirBuffet(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
        {
            $session = $request->getSession();
            if ($session->has('ideUsuario')) {
                if ($request->getMethod() == 'POST') {
                    return $this->redirect($this->generateUrl('login'));
                } else { // ES GET
                    $em = $doctrine->getManager();

                    $BuffetMes = $request->get('BuffetMes');

                    $primer_Dia = $BuffetMes . "-01";
                    $Ultimo_dia = new \DateTime($primer_Dia);
                    $Ultimo_dia->modify('Last day of this month');


                    /*
                    $Buf = $em->getRepository(Servicios::class)
                        ->findOneBy(['ideSer' => $Buf]);

                    $ff = $em->getRepository(Servicios::class)
                        ->findOneBy(['CveTipSer' => $ff]);


                    $dql = "SELECT "
                        . "s.fecMov FECHA_DE_MOVIMIENTO, "
                        . "COUNT(s.ideSer ) TOTAL1, "
                        . "IDENTITY(sm.cveMen) TIPO_MENU, "
                        . "m.nomMen NOMBRE_MENU, "
                        . "COUNT(IDENTITY(sm.cveMen)) TOTAL2 "
                        . "FROM "
                        . "App\Entity\Servicios s, "
                        . "App\Entity\ServiciosMenu sm, "
                        . "App\Entity\Menus m "
                        . "WHERE "
                        . "s.ideSer = sm.cveSer "
                        . "AND "
                        . "sm.cveMen = m.ideMen "
                        . "AND "
                        . "sm.cveMen IN( SELECT men.ideMen FROM App\Entity\Menus men WHERE men.cveCatMen IN(1) ) "
                        . "AND s.fecMov BETWEEN "
                        . "'" . $fechaInicio . "'"
                        . "AND "
                        . "'" . $fechaFin->format('Y/m/d') . "'"
                        . "GROUP BY s.fecMov, sm.cveMen ";


                    $dql = "SELECT s.fecMov, "
                        . " COUNT(s.ideSer) total, "
                        . "IDENTITY(m.cveMen), "
                        . "COUNT((m.cveMen)) categoria "
                        . " FROM App\Entity\Servicios s,App\Entity\ServiciosMenu m "
                        . "WHERE s.ideSer = m.cveSer "
                        . "AND m.cveMen IN( "
                        . "SELECT mm.ideMen "
                        . " FROM App\Entity\Menus mm "
                        . "WHERE mm.cveCatMen IN(1)) "
                        . "AND s.fecMov BETWEEN "
                        . "'" . $primer_Dia . "'"
                        . "AND "
                        . "'" . $Ultimo_dia->format('Y/m/d') . "'"
                        . "GROUP BY s.fecMov, m.cveMen ";


                    $query = $entityManager->createQuery($dql);
                    $res = $query->getResult();

                    $pdfb = new PdfReportes('L', 'mm', 'letter');
                    $pdfb->SetFont('Helvetica', '', 8);
                    $pdfb->AddPage();
                    $pdfb->SetLeftMargin(10);
                    $pdfb->SetRightMargin(10);
                    $pdfb->BuffetPorMes($res, $BuffetMes);


                    return new Response(
                        $pdfb->Output('BuffetDelMes_' . $BuffetMes . '.pdf', 'I'),
                        200,
                        array('Content-Type' => 'application/pdf')
                    );
                }
            } else {
                return $this->redirect($this->generateUrl('login'));
            }
        }*/

    #[Route('/imprimirCorteDiaBuffet', name: 'imprimir_corte_Dia_Buffet')]
    public function imprimirCorteDiaBuffet(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET

                $em = $doctrine->getManager();

                $fechaBuffet = $request->get('cortePorFechaDia');

                if ($fechaBuffet == null) {
                    $hoy = date('d-m-Y');
                } else {
                    $hoy = date($fechaBuffet);
                }

                $dql = "SELECT "
                    . "s.fecMov FECHA, "
                    . "s.horMov HORA, "
                    . "COUNT(s.ideSer ) TOTAL, "
                    . "IDENTITY(sm.cveMen) TIPO_DE_MENU, "
                    . "m.nomMen NOM_MENU, "
                    . "COUNT(IDENTITY(sm.cveMen)) TOTAL1 "
                    . "FROM "
                    . "App\Entity\Servicios s, "
                    . "App\Entity\ServiciosMenu sm, "
                    . "App\Entity\Menus m "
                    . "WHERE "
                    . "s.ideSer = sm.cveSer "
                    . "AND "
                    . "sm.cveMen = m.ideMen "
                    . "AND "
                    . "sm.cveMen IN( SELECT men.ideMen FROM App\Entity\Menus men WHERE men.cveCatMen IN(1) ) "
                    . "AND s.fecMov = "
                    . "'" . $hoy . "' "
                    . "GROUP BY "
                    . "s.fecMov, sm.cveMen,m.nomMen";

                $query = $entityManager->createQuery($dql);
                $ingresosBuffet = $query->getResult();

                $dql1 = "SELECT "
                    . "s.fecMov FECHA, "
                    . "s.horMov HORA, "
                    . "m.nomMen NOMBRE_MENU, "
                    . "m.precio PRECIO "
                    . "FROM App\Entity\Servicios s , App\Entity\ServiciosMenu sm, App\Entity\Menus m "
                    . "WHERE s.ideSer = sm.cveSer "
                    . "AND "
                    . "sm.cveMen = m.ideMen "
                    . "AND "
                    . "sm.cveMen "
                    . "IN (SELECT men.ideMen FROM App\Entity\Menus men WHERE men.cveCatMen IN (1)) "
                    . "AND "
                    . "s.fecMov = "
                    . "'" . $hoy . "' "
                    . "ORDER BY s.fecMov, m.nomMen";

                $query = $entityManager->createQuery($dql1);
                $detallesMenu = $query->getResult();


                $pdf = new PdfReportes('P', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->BuffetDia($ingresosBuffet, $hoy, $detallesMenu);
                return new Response(
                    $pdf->Output('ingresosBuffet_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirBuffetMes', name: 'imprimir_Buffet_Mes')]
    public function imprimirBuffetMes(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $BuffetPorMes = $request->get('corteBuffetPorMes');

                $primerDia = $BuffetPorMes . "-01";
                $fechaFin = new \DateTime($primerDia);
                $fechaFin->modify('Last day of this month');

                $dql = "SELECT "
                    . "s.fecMov FECHA_DE_MOVIMIENTO, "
                    . "COUNT(s.ideSer ) TOTAL1, "
                    . "IDENTITY(sm.cveMen) TIPO_MENU, "
                    . "m.nomMen NOMBRE_MENU, "
                    . "COUNT(IDENTITY(sm.cveMen)) TOTAL2 "
                    . "FROM "
                    . "App\Entity\Servicios s, "
                    . "App\Entity\ServiciosMenu sm, "
                    . "App\Entity\Menus m "
                    . "WHERE "
                    . "s.ideSer = sm.cveSer "
                    . "AND "
                    . "sm.cveMen = m.ideMen "
                    . "AND "
                    . "s.fecMov BETWEEN '" . $primerDia . "' AND '" . $fechaFin->format('Y-m-d') . "' "
                    . "GROUP BY "
                    . "s.fecMov, sm.cveMen";


                $query = $entityManager->createQuery($dql);
                $serviciosBuffet = $query->getResult();

                $dql2 = "SELECT "
                    . "m.nomMen, "
                    . "s.fecMov, "
                    . "COUNT(m.nomMen) "
                    . "FROM "
                    . "App\Entity\Servicios s, App\Entity\ServiciosMenu sm, App\Entity\Menus m "
                    . "WHERE "
                    . "m.ideMen = sm.cveMen "
                    . "AND "
                    . "s.ideSer = sm.cveSer "
                    . "AND "
                    . "s.fecMov "
                    . "BETWEEN "
                    . "' " . $primerDia . "' "
                    . "AND "
                    . "' " . $fechaFin->format('Y-m-d') . "' "
                    . "GROUP BY "
                    . "m.nomMen ";
                $query = $entityManager->createQuery($dql2);
                $gastosGenerales = $query->getResult();

                $dql3 = "SELECT "
                    . "s.fecMov FECHA_DE_MOVIMIENTO, "
                    . "COUNT(s.ideSer) TOTAL1, "
                    . "IDENTITY(sm.cveMen) TIPO_MENU, "
                    . "m.nomMen NOMBRE_MENU, "
                    . "m.precio PRECIO, "
                    . "COUNT(IDENTITY(sm.cveMen)) TOTAL2 "
                    . "FROM "
                    . "App\Entity\Servicios s, "
                    . "App\Entity\ServiciosMenu sm, "
                    . "App\Entity\Menus m "
                    . "WHERE "
                    . "s.ideSer = sm.cveSer "
                    . "AND "
                    . "sm.cveMen = m.ideMen "
                    . "AND "
                    . "s.fecMov BETWEEN '" . $primerDia . "' AND '" . $fechaFin->format('Y-m-d') . "' "
                    . "GROUP BY "
                    . "sm.cveMen "
                    . "ORDER BY "
                    . "m.nomMen ASC";

                $query = $entityManager->createQuery($dql3);
                $gastosGenerales2 = $query->getResult();


                $pdf = new PdfNotas('P', 'mm', 'letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(10);
                $pdf->SetRightMargin(10);
                $pdf->buffetPorMes($serviciosBuffet, $BuffetPorMes, $gastosGenerales2);


                return new Response(
                    $pdf->Output('BuffetDelMes_' . $primerDia . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/cancelarTicket', name: 'cancelar_ticket')]
    public function cancelarTicket(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $ideServicio = $request->get('ideSer');
                $cancelarServicio = $request->get('ideCancelarServicio');

                $servicio = $em->getRepository(Servicios::class)
                    ->findOneBy(['ideSer' => $ideServicio]);

                $servicio->setCancelarServicio($cancelarServicio);

                $em->persist($servicio);
                $em->flush();

                return $this->redirect($this->generateUrl('listar_notas'));

            } else {
                return $this->render('Pagos/contenedor-cancelar-ticket.html.twig');
            }
        } else {
            return $this->redirect($this->generateUrl('listar_notas'));
            // return $this->render('Pagos/contenedor-cancelar-ticket.html.twig');
        }
    }


}
