<?php

namespace App\Controller;

use ContainerBQkhVHp\getConsole_ErrorListenerService;
use Fpdf\Fpdf;

date_default_timezone_set('America/Mexico_City');

class PdfNotas extends Fpdf
{
    function Header()
    {
        $this->Image('assets/media/logos/mh.png', 0, 0, 280);

        $this->Ln(20);
    }

    function reporteDelMes($resultados, $mes)
    {
        /**
         * INICIA EL ENCABEZADO
         */

        {
            $sumaGeneral = 0;
            $sumaGeneralProp = 0;
            $sumPropinaEfectivo = 0;
            $sumPropinaTransferencia = 0;
            $sumPagoEfectivo = 0;
            $sumPagoTransferencia = 0;
            $media = 0;
            $this->SetY(20);
            $this->SetFont('helvetica', 'B', '15');
            $this->Cell(160, 7, utf8_decode("REPORTE DEL MES"), 0, 0, 'R', false);
            $this->Ln();
            $this->Cell(145, 7, utf8_decode($mes), 0, 0, 'R', false);
            //    $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);
            if (count($resultados) == 0) {
                $this->Ln(50);
                $this->Cell(150, 8, utf8_decode("¡NO HAY DATOS! --°0°--"), 0, 0, "R", false);
                $this->SetFont('helvetica', '', '8');
            } else {
                $this->Ln(15);
                $this->SetFont('helvetica', 'B', '8');
                $this->SetX(30);
                $this->SetTextColor(255, 255, 255);
                $this->SetFillColor(48, 149, 124);
                $this->Cell(10, 8, utf8_decode("#"), 1, 0, "C", true);
                $this->cell(20, 8, utf8_decode("FECHA"), 1, 0, "C", true);
                $this->Cell(14, 8, utf8_decode("MESA"), 1, 0, "C", true);
                $this->Cell(25, 8, utf8_decode("NOTA"), 1, 0, 'C', true);
                $this->Cell(25, 8, utf8_decode("RECIBO"), 1, 0, 'C', true);
                $this->Cell(27, 8, utf8_decode("TOTAL"), 1, 0, 'C', true);
                $this->Cell(43, 8, utf8_decode("TIPO PAGO"), 1, 0, "C", true);
                $this->Cell(27, 8, utf8_decode("POPINA"), 1, 0, "C", true);
                $this->Cell(33, 8, utf8_decode("TIPO PAGO"), 1, 0, "C", true);
                $this->Ln();
                $this->SetFont('helvetica', '', '8');
                $this->SetTextColor(0, 0, 0);

                foreach ($resultados as $k => $r) {
                    $sumaGeneral = $sumaGeneral + $r->getTotal();
                    $sumaGeneralProp = $sumaGeneralProp + $r->getPropina();
                    $media = $sumaGeneral / $r->getFecMov()->format('d');
                    $this->SetX(30);
                    $this->Cell(10, 8, utf8_decode($k + 1), 1, 0, "C", false);
                    $this->cell(20, 8, utf8_decode($r->getFecMov()->format('d/m/Y')), 1, 0, "L", false);
                    $this->Cell(14, 8, utf8_decode($r->getCveSerCue()->getCveSer()->getCveMes()->getCveMesa()), 1, 0, "L", false);
                    $this->Cell(25, 8, utf8_decode($r->getCveSerCue()->getCveSer()->getIdeser()), 1, 0, 'L', false);
                    $this->Cell(25, 8, utf8_decode($r->getRecibo()), 1, 0, 'C', false);
                    $this->Cell(27, 8, utf8_decode('$' . $r->getTotal()), 1, 0, 'R', false);
                    $this->Cell(43, 8, utf8_decode($r->getCveModPag()->getModoPago()), 1, 0, "L", false);
                    if ($r->isBanderaPropina() == 0) { //Sin propina
                        $this->SetFont('helvetica', 'B', '8');
                        $this->Cell(27, 8, utf8_decode("SIN PROPINA"), 1, 0, 'L', false);
                        $this->Cell(33, 8, utf8_decode(""), 1, 0, "L", false);
                        $this->Ln();
                        $this->SetFont('helvetica', '', '8');
                    } else {//Con propina

                        $this->Cell(27, 8, utf8_decode('$' . $r->getPropina()), 1, 0, 'R', false);
                        $this->Cell(33, 8, utf8_decode($r->getCveModPag()->getModoPago()), 1, 0, "L", false);
                        $this->Ln();
                    }

                    if ($r->getCveModPagPropina() == null) {

                    } else {
                        if ($r->getCveModPagPropina()->getIdeModPag() == 1) { // EFECTIVO
                            $sumPropinaEfectivo += $r->getPropina();
                        } else { // TRANSFERENCIA
                            $sumPropinaTransferencia += $r->getPropina();
                        }

                        if ($r->getCveModPag()->getIdeModPag() == 1) { // EFECTIVO
                            $sumPagoEfectivo += $r->getTotal();
                        } else { // TRANSFERENCIA
                            $sumPagoTransferencia += $r->getTotal();
                        }
                    }
                }
                $this->SetFont('helvetica', 'B', '8');
                $this->Cell(30, 10, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(84, 10, utf8_decode("NOTAS EN EFECTIVO"), 1, 0, "L", false);
                $this->Cell(27, 10, '$' . number_format($sumPagoEfectivo, 2, "."),
                    1, 0, 'R', false);

                $this->Cell(43, 10, utf8_decode("PROPINAS EN EFECTIVO"), 1, 0, "L", false);
                $this->Cell(27, 10, '$' . number_format($sumPropinaEfectivo, 2, "."),
                    1, 0, 'R', false);
                $this->SetFont('helvetica', 'B', '8');

                $this->Ln();
                $this->Cell(30, 10, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(84, 10, utf8_decode("NOTAS EN TRANSFERENCIA"), 1, 0, "L", false);
                $this->Cell(27, 10, '$' . number_format($sumPagoTransferencia, 2, "."),
                    1, 0, 'R', false);
                $this->SetFont('helvetica', 'B', '7');

                $this->Cell(43, 10, utf8_decode("PROPINAS POR TRANSFERENCIAS"), 1, 0, "L", false);
                $this->SetFont('helvetica', 'B', '8');

                $this->Cell(27, 10, '$' . number_format($sumPropinaTransferencia, 2, "."),
                    1, 0, 'R', false);
                $this->SetFont('helvetica', 'B', '8');

                $this->Ln();
                $this->Cell(114, 10, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(27, 10, '$' . number_format($sumaGeneral, 2, "."),
                    1, 0, 'R', false);
                $this->Cell(43, 10, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(27, 10, '$' . number_format($sumaGeneralProp, 2, "."),
                    1, 0, 'R', false);
                $this->Ln(20);
                $this->Cell(30, 10, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(84, 10, utf8_decode("MEDIA"), 1, 0, "L", false);
                $this->Cell(27, 10, '$' . number_format($media, 2, "."),
                    1, 0, 'R', false);
                /*

                                $this->Ln(20);
                                $this->Cell(30, 10, utf8_decode(""), 0, 0, 'R', false);
                                $this->Cell(84, 10, utf8_decode("MEDIA"), 1, 0, "L", false);
                                $this->Cell(27, 10, '$' . number_format($media, 2, "."),
                                    1, 0, 'R', false);*/
            }
        }
    }

    function buffetPorMes($serviciosBuffet, $mes, $gastosGenerales2)
    {
        /**
         * INICIA EL ENCABEZADO
         */
        $this->SetY(20);
        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(150, 7, utf8_decode("REPORTE DEL MES"), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(135, 7, utf8_decode($mes), 0, 0, 'R', false);

        $matrizDatos = [];

        $fecha = "";
        $auxDatos = "";

        if (count($serviciosBuffet) == 0) {

            $this->SetXY(25, 100);
            $this->SetXY(70, 160);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(135, 163, 241);

            $this->Cell(120, 9, utf8_decode("NO HAY NINGÚN REGISTRO EN ESTA FECHA"), 1, 0, 'C', true);

        } else {
            $this->Ln(15);
            $this->SetX(20);
            $this->SetFont("", "B", 12);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(35, 8, utf8_decode("FECHA"), 1, 0, 'C', true);
            $this->Cell(60, 8, utf8_decode("NOMBRE"), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode("TOTAL "), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode("TOTAL POR DÍA"), 1, 0, 'C', true);


            $this->SetTextColor(0, 0, 0);
            $this->Ln();
            $this->SetFont('helvetica', '', '10');

            $datos = array();
            foreach ($serviciosBuffet as $ib) {

                $fecha = $ib['FECHA_DE_MOVIMIENTO']->format('d/m/Y');
                $tipo_menu = $ib['TIPO_MENU'];
                $nombre_menu = $ib['NOMBRE_MENU'];
                $total2 = $ib['TOTAL2'];
                if (!isset($datos[$fecha][$tipo_menu])) {
                    $datos[$fecha][$tipo_menu] = array(
                        'NOMBRE_MENU' => $nombre_menu,
                        'TOTAL2' => $total2
                    );
                } else {
                    $datos[$fecha][$tipo_menu]['TOTAL2'] += $total2;
                }
            }
            $totalGeneral = 0;

            $this->SetX(70);
            foreach ($datos as $key => $d) {
                $this->SetX(20);
                $this->Cell(35, count($d) * 8, utf8_decode($key), 1, 0, 'C', false); // La altura de la celda se calcula en función del número de tipos de menú
                $totalPorBuffet = 0;
                foreach ($d as $key => $dd) {
                    $totalPorBuffet += $dd['TOTAL2'];
                }
                $this->Cell(105, count($d) * 8, "", 0, 0, 'C', false);
                $this->Cell(45, count($d) * 8, ($totalPorBuffet), 1, 0, 'C', false);

                foreach ($d as $key => $ddd) {
                    $this->SetX(55);
                    $this->Cell(60, 8, utf8_decode($ddd['NOMBRE_MENU']), 1, 0, 'J', false);
                    $this->Cell(45, 8, utf8_decode($ddd['TOTAL2']), 1, 0, 'C', false);
                    $this->Ln();
                }
                $totalGeneral += $totalPorBuffet;


                $this->Ln();
            }

        }


        $this->AddPage();
        $total = 0;
        $suma = 0;
        if ($gastosGenerales2 == null) {

        } else {
            $this->SetTextColor(255, 255, 255);
            $this->SetFont('helvetica', 'B', '10');

            $this->Cell(45, 8, utf8_decode("#"), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode('NOMBRE'), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode('VENTA TOTAL'), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode('INGRESO'), 1, 0, 'C', true);
            //$total = $g['TOTAL1'] * $g['PRECIO'];
            //$this->Cell(45, 8, '$' . number_format($total, 2, '.'), 1, 0, 'C');
            foreach ($gastosGenerales2 as $i => $g) {
                $this->Ln();
                $this->SetTextColor(0, 0, 0);
                $this->SetFont('helvetica', '', '10');
                $this->Cell(45, 8, utf8_decode($i + 1), 1, 0, 'C', false);
                $this->Cell(45, 8, utf8_decode($g['NOMBRE_MENU']), 1, 0, 'L', false);
                $this->Cell(45, 8, utf8_decode($g['TOTAL1']), 1, 0, 'C', false);
                $total = $g['TOTAL1'] * $g['PRECIO'];
                $this->Cell(45, 8, '$' . number_format($total, 2, '.'), 1, 0, 'C');

                $suma = $suma + $total;

                //  $this->Cell(45, count($g) * 8, (), 1, 0, 'C', false);

            }
            $this->Ln();
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->SetFont('helvetica', 'B', '10');
            $this->Cell(135, 8, '', 0, 0, 'C', false);
            $this->Cell(45, 8, '$' . number_format($suma, 2, '.'), 1, 0, 'C', true);

        }

    }

    function imprimirGastosMes($g, $Mes, $resumenG, $resumenGT)
    {
//FALTA COLOCAR EL MEMBRETADO
        $sumaGeneral = 0;

        $this->SetY(15);
        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("GASTOS DEL MES"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 8, $Mes, 0, 0, 'C', false);
        $this->Ln(30);

        $sumaResumen = 0;
        $sumaResumenT = 0;
        if (count($resumenG) == 0) {

        } else {
            $this->SetFont('helvetica', 'B', '9');
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 8, utf8_decode('GASTOS EN EFECTIVO'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(15, 8, utf8_decode('#'), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode('TOTAL POR GASTO'), 1, 0, 'C', true);
            $this->Cell(50, 8, utf8_decode('DESCRIPCIÓN'), 1, 0, 'C', true);
            $this->Cell(40, 8, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont('helvetica', '', '9');

            foreach ($resumenG as $key => $r) {
                $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);

                $this->Cell(15, 8, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(35, 8, utf8_decode($r['COUNT_DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(50, 8, utf8_decode($r['DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(40, 8, '$' . number_format($r['SUMA'], 2, "."), 1, 0, 'R', false);
                $sumaResumen += $r['SUMA'];
                $this->Ln();
            }
            $this->SetTextColor(255, 255, 255);
            $this->SetFont('helvetica', 'B', '9');
            $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(100, 8, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->SetTextColor(0, 0, 0);

            $this->Cell(40, 8, '$' . number_format($sumaResumen, 2, "."), 1, 0, 'R', false);

        }

        $this->Ln(15);
        if (count($resumenGT) == 0) {

        } else {
            $this->SetFont('helvetica', 'B', '9');

            //$this->Cell(35, 10, utf8_decode('SI HAY DATOS'), 1, 0, 'C', true);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 8, utf8_decode('GASTOS EN TRANSFERENCIAS'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(15, 8, utf8_decode('#'), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode('TOTAL POR GASTO'), 1, 0, 'C', true);
            $this->Cell(50, 8, utf8_decode('DESCRIPCIÓN'), 1, 0, 'C', true);
            $this->Cell(40, 8, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont('helvetica', '', '9');

            foreach ($resumenGT as $key => $gt) {
                $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);

                $this->Cell(15, 8, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(35, 8, utf8_decode($gt['COUNT_DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(50, 8, utf8_decode($gt['DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(40, 8, '$' . number_format($gt['SUMA'], 2, "."), 1, 0, 'R', false);
                $sumaResumenT += $gt['SUMA'];
                $this->Ln();
            }
            $this->SetTextColor(255, 255, 255);
            $this->SetFont('helvetica', 'B', '9');
            $this->Cell(50, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(100, 8, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->SetTextColor(0, 0, 0);

            $this->Cell(40, 8, '$' . number_format($sumaResumenT, 2, "."), 1, 0, 'R', false);

        }


        if (count($g) == 0) {
            $this->Cell(183, 8, utf8_decode('SIN REGISTROS EN EL MES'), 1, 0, 'C', false);
        } else {
            $this->AddPage();
            $this->SetFont("", "B", 10);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(0, 0, 0);

            $this->Ln();
            $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(203, 10, utf8_decode('DETALLE DE GASTOS GENERALES'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 10, utf8_decode('N°'), 1, 0, 'C', true);
            $this->Cell(45, 10, utf8_decode('Descripcion Gasto'), 1, 0, 'C', true);
            $this->Cell(22, 10, utf8_decode('Fecha.T'), 1, 0, 'C', true);
            $this->Cell(24, 10, utf8_decode('Hora T'), 1, 0, 'C', true);
            $this->Cell(35, 10, utf8_decode('Fecha Movimiento'), 1, 0, 'C', true);
            $this->Cell(30, 10, utf8_decode('Hora de M'), 1, 0, 'C', true);
            $this->Cell(27, 10, utf8_decode('Total Monto'), 1, 0, 'C', true);
            $this->Ln(10);
            $this->SetFont("", "", 8);
            $this->SetTextColor(0, 0, 0);

            foreach ($g as $k => $t) {
                $sumaGeneral = $sumaGeneral + $t->getTotMon();

                $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(20, 10, utf8_decode($k + 1), 1, 0, 'C', false);

                if ($t->getCveCatGast() == null) {
                    $this->Cell(45, 10, utf8_decode(""), 1, 0, 'L', false);
                } else {
                    $this->Cell(45, 10, utf8_decode($t->getCveCatGast()->getDescripcion()), 1, 0, 'L', false);
                }
                $this->Cell(22, 10, utf8_decode($t->getFecMovGast()->format('d/m/Y')), 1, 0, 'R', false);
                $this->Cell(24, 10, utf8_decode($t->getHorMovGast()->format('H:i')), 1, 0, 'R', false);
                $this->Cell(35, 10, utf8_decode($t->getFecMov()->format('Y/m/d')), 1, 0, 'C', false);
                $this->Cell(30, 10, utf8_decode($t->getHorMov()->format('H:i')), 1, 0, 'R', false);
                $this->Cell(27, 10, utf8_decode('$' . $t->getTotMon()), 1, 0, 'R', false);
                $this->Ln();


            }
            $this->SetFont("", "B", 9);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(156, 10, utf8_decode('TOTAL GASTOS MES:'), 1, 0, 'L', true);
            $this->Cell(27, 10, '$' . number_format($sumaGeneral, 2, "."), 1, 0, 'R', true);
        }
    }

    function corteDiarioCta($ingreso, $fecha)
    {
        /**
         * INICIA EL ENCABEZADO
         */
        $this->SetY(20);
        $this->SetFont('Helvetica', 'B', 15);
        $this->Cell(0, 5, utf8_decode("FECHA DEL CORTE"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('Helvetica', 'B', 13);
        $this->Cell(0, 5, utf8_decode($fecha), 0, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(30);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln(4);
        /**
         * TERMINA EL ENCABEZADO
         */
        $sumEfectivo = 0;
        $sumTransferencia = 0;
        $sumPropinaEfectivo = 0;
        $sumPropinaTransferencia = 0;

        if (count($ingreso) == 0) {
            $this->SetFont('Helvetica', '', 12);

            $this->Ln(6);
            $this->Cell(0, 2, utf8_decode("SIN REGISTROS"), 0, 0, 'C', false);
            $this->Ln();
        } else {
            foreach ($ingreso as $k => $i) {

                $this->Ln(3);
                $this->SetFont("", "", 10);
                $this->Cell(50, 2, utf8_decode(""), 0, 0, 'L', false);
                $this->Cell(6, 2, utf8_decode("#" . $k + 1), 0, 0, 'L', false);
                $this->Cell(13, 2, utf8_decode("Mesa: " . $i->getCveSerCue()->getCveSer()->getCveMes()->getCveMesa()), 0, 0, 'L', false);
                $this->Cell(160, 2, utf8_decode("Nota: " . $i->getCveSerCue()->getCveSer()->getIdeSer()), 0, 0, 'R', false);
                $this->Ln(4);
                $this->Cell(229, 2, utf8_decode("Recibo: " . $i->getRecibo()), 0, 0, 'R', false);
                $this->Ln(4);
                $this->Cell(63, 2, utf8_decode("$" . $i->getTotal()), 0, 0, 'R', false);
                $this->Cell(147, 2, utf8_decode($i->getCveModPag()->getModoPago()), 0, 0, 'C', false);
                $this->Ln(4);
                $this->Ln(4);

                $this->Cell(50, 2, utf8_decode(""), 0, 0, 'L', false);
                $this->Cell(22, 2, utf8_decode("PROPINA:"), 0, 0, 'L', false);
                $this->Ln(4);
                $this->Ln(4);


                if ($i->isBanderaPropina() == 1) {
                    $this->Cell(64, 2, utf8_decode("$ " . number_format($i->getPropina(), 2, '.', ',')), 0, 0, 'R', false);
                    $this->Cell(145, 2, utf8_decode($i->getCveModPagPropina()->getModoPago()), 0, 0, 'C', false);

                    if ($i->getCveModPagPropina()->getIdeModPag() == 1) { // EFECTIVO
                        $sumPropinaEfectivo += $i->getPropina();
                    } else { // TRANSFERENCIA
                        $sumPropinaTransferencia += $i->getPropina();
                    }

                } else {
                    $this->Cell(0, 2, utf8_decode("SIN REGISTRO DE PROPINA"), 0, 0, 'C', false);
                }


                if ($i->getCveModPag()->getIdeModPag() == 1) { // EFECTIVO
                    $sumEfectivo += $i->getTotal();
                } else { // TRANSFERENCIA
                    $sumTransferencia += $i->getTotal();
                }
                $this->Ln();
                $this->Ln();
                $this->Ln();
                $this->Cell(40, 1, utf8_decode(""), 0, 0, 'C', false);

                $this->Cell(200, 1, utf8_decode(""), 1, 0, 'R', false);

            }
        }

        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln(6);

        $this->Cell(20, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(0, 2, utf8_decode("TOTAL EFECTIVO"), 0, 0, 'L', false);
        $this->Ln();

        $this->Cell(110, 2, utf8_decode(""), 0, 0, 'L', false);
        $this->Cell(140, 5, utf8_decode("$ " . number_format($sumEfectivo, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);

        $this->Cell(20, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(0, 2, utf8_decode("TOTAL TRANSFERENCIA"), 0, 0, 'L', false);
        $this->Ln();

        $this->Cell(110, 2, utf8_decode(""), 0, 0, 'L', false);
        $this->Cell(140, 5, utf8_decode("$ " . number_format($sumTransferencia, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln(6);

        $this->Cell(20, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(0, 2, utf8_decode("PROPINA EFECTIVO"), 0, 0, 'L', false);
        $this->Ln();

        $this->Cell(110, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(140, 5, utf8_decode("$ " . number_format($sumPropinaEfectivo, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);

        $this->Cell(20, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(0, 2, utf8_decode("PROPINA TRANSFERENCIA"), 0, 0, 'L', false);
        $this->Ln();

        $this->Cell(110, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(140, 5, utf8_decode("$ " . number_format($sumPropinaTransferencia, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);

        $this->Cell(20, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(0, 2, utf8_decode("TOTAL PROPINA:"), 0, 0, 'L', false);
        $this->Ln();

        $this->Cell(110, 2, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(140, 5, utf8_decode("$ " . number_format(($sumPropinaEfectivo + $sumPropinaTransferencia), 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
    }

    function imprimirCorteGeneralMes($reporteGeneralMes, $fechaGeneral, $reporteGeneralMesT)
    {
        /**
         * INICIA EL ENCABEZADO
         */
        $meses = array(
            1 => 'ENERO',
            2 => 'FEBRERO',
            3 => 'MARZO',
            4 => 'ABRIL',
            5 => 'MAYO',
            6 => 'JUNIO',
            7 => 'JULIO',
            8 => 'AGOSTO',
            9 => 'SEPTIEMBRE',
            10 => 'OCTUBRE',
            11 => 'NOVIEMBRE',
            12 => 'DICIEMBRE'
        );

        // Get the month component from $fechaGeneral
        $month = intval(date('m', strtotime($fechaGeneral)));

        // Check if $month is a valid month
        if (isset($meses[$month])) {
            $nombreMes = $meses[$month];
        } else {
            $nombreMes = 'Mes desconocido';
        }
        $this->SetXY(168, 5);
        $this->SetFont('helvetica', 'B', 10);
        $this->SetTextColor(0, 0, 0);
        $this->SetFillColor(255, 255, 255);
        $this->Cell(70, 7, utf8_decode("INGRESOS & GASTOS DEL MES DE:"), 0, 0, 'R', true);
        $this->Cell(20, 7, ($nombreMes), 0, 0, 'L', true);
        $this->Ln(10);


        $sumaServiciosT = 0;
        $ingresosT = 0;
        $gastosT = 0;

        $sumaServiciosE = 0;
        $ingresosE = 0;
        $gatosE = 0;

        $sumaGeneralIngresosGastos = 0;


        $restagastoIngresoT = 0;
        $restagastoIngresoE = 0;


        $this->SetY(11.5);
        if (count($reporteGeneralMesT) == 0) {
            $this->Cell(100, 7, utf8_decode("NO HAY DATOS POR MOSTRAR:"), 1, 0, 'C', false);
        } else {
            $this->SetFont("", "B", 6.5);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(15, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(115, 6, utf8_decode("INGRESOS & GASTOS  ''TRANSFERENCIA''"), 1, 0, 'C', true);
            $this->Ln();
            $this->Cell(15, 6, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(10, 6, utf8_decode("#"), 1, 0, 'C', true);
            $this->Cell(30, 6, utf8_decode("FECHA PAGO"), 1, 0, 'C', true);
            $this->Cell(25, 6, utf8_decode("N° SERVICIOS"), 1, 0, 'C', true);
            $this->Cell(25, 6, utf8_decode("$ INGRESOS"), 1, 0, 'C', true);

            $this->Cell(25, 6, utf8_decode("$ GASTO"), 1, 0, 'C', true);


            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFillColor(255, 255, 255);
            foreach ($reporteGeneralMesT as $K => $rt) {
                $this->Cell(15, 5, utf8_decode(""), 0, 0, 'R', false);
                $this->SetFont("", "B", 6.5);
                $this->Cell(10, 5, utf8_decode($K + 1), 1, 0, 'C', true);
                $this->SetFont("", "", 6.5);
                $this->Cell(30, 5, utf8_decode($rt['FECHA_INGRESO']->format('d/m/Y')), 1, 0, 'C', true);
                $this->Cell(25, 5, utf8_decode($rt['N_TICKET']), 1, 0, 'C', true);
                $this->Cell(25, 5, '$' . number_format($rt['TOTAL_INGRESOS'], 2, "."), 1, 0, 'C', true);
                $this->Cell(25, 5, '$' . number_format($rt['TOTAL_GASTOS'], 2, "."), 1, 0, 'C', true);
                $sumaServiciosT += $rt['N_TICKET'];
                //$totalServicioCuenta += $rt['TOTAL_ESPERADO'];
                $ingresosT += $rt['TOTAL_INGRESOS'];
                $gastosT += $rt['TOTAL_GASTOS'];
                $restagastoIngresoT = $ingresosT - $gastosT;
                $this->Ln();

            }
            $this->SetFont("", "B", 8);
            $this->Cell(15, 5, utf8_decode(""), 0, 0, 'C', false);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(40, 5, utf8_decode("TOTAL GENERAL POR MES"), 1, 0, 'C', true);

            $this->Cell(25, 5, utf8_decode($sumaServiciosT), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($ingresosT, 2, "."), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($gastosT, 2, "."), 1, 0, 'C', true);
            $this->Ln(7);
            $this->Cell(15, 5, utf8_decode(""), 0, 0, 'C', false);
            $this->Cell(90, 5, utf8_decode("TOTAL RESTANTE"), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($restagastoIngresoT, 2, "."), 1, 0, 'C', true);
            $this->SetFont("", "B", 9);

        }


        $this->SetY(11.5);
        if (count($reporteGeneralMes) == 0) {
            $this->Cell(0, 7, utf8_decode("NO HAY DATOS POR MOSTRAR:"), 0, 0, 'C', false);
        } else {

            $this->SetFont("", "B", 6.5);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(140, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(115, 6, utf8_decode("INGRESOS & GASTOS  ''EFECTIVO''"), 1, 0, 'C', true);
            $this->Ln();
            $this->Cell(140, 6, utf8_decode(""), 0, 0, 'C', false);
            $this->Cell(10, 6, utf8_decode("#"), 1, 0, 'C', true);
            $this->Cell(30, 6, utf8_decode("FECHA PAGO"), 1, 0, 'C', true);
            $this->Cell(25, 6, utf8_decode("N° SERVICIOS"), 1, 0, 'C', true);
            $this->Cell(25, 6, utf8_decode("$ INGRESOS"), 1, 0, 'C', true);
            $this->Cell(25, 6, utf8_decode("$ GASTO"), 1, 0, 'C', true);


            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFillColor(255, 255, 255);

            foreach ($reporteGeneralMes as $k => $rg) {

                $this->Cell(140, 5, utf8_decode(""), 0, 0, 'R', false);
                $this->SetFont("", "B", 6.5);
                $this->Cell(10, 5, utf8_decode($k + 1), 1, 0, 'C', true);
                $this->SetFont("", "", 6.5);
                $this->Cell(30, 5, utf8_decode($rg['FECHA_INGRESO']->format('d/m/Y')), 1, 0, 'C', true);
                $this->Cell(25, 5, utf8_decode($rg['N_TICKET']), 1, 0, 'C', true);
                $this->Cell(25, 5, '$' . number_format($rg['TOTAL_INGRESOS'], 2, "."), 1, 0, 'C', true);
                $this->Cell(25, 5, '$' . number_format($rg['TOTAL_GASTOS'], 2, "."), 1, 0, 'C', true);
                $sumaServiciosE += $rg['N_TICKET'];
                // $totalServicioCuenta += $rg['TOTAL_ESPERADO'];
                $ingresosE += $rg['TOTAL_INGRESOS'];
                $gatosE += $rg['TOTAL_GASTOS'];
                $restagastoIngresoE = $ingresosE - $gatosE;
                $this->Ln();
            }
            $this->SetFont("", "B", 8);
            $this->Cell(140, 5, utf8_decode(""), 0, 0, 'C', false);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(40, 5, utf8_decode("TOTAL GENERAL POR MES"), 1, 0, 'C', true);
            $this->Cell(25, 5, utf8_decode($sumaServiciosE), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($ingresosE, 2, "."), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($gatosE, 2, "."), 1, 0, 'C', true);
            $this->Ln(7);

            $this->Cell(140, 5, utf8_decode(""), 0, 0, 'C', false);
            $this->Cell(90, 5, utf8_decode("TOTAL RESTANTE"), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($restagastoIngresoE, 2, "."), 1, 0, 'C', true);

            $this->Ln(7);

            $sumaGeneralIngresosGastos = $restagastoIngresoT + $restagastoIngresoE;
            $this->Cell(15, 5, utf8_decode(""), 0, 0, 'C', false);
            $this->Cell(90, 5, utf8_decode("TOTAL GENERAL"), 1, 0, 'C', true);
            $this->Cell(25, 5, '$' . number_format($sumaGeneralIngresosGastos, 2, "."), 1, 0, 'C', true);


        }
        /*$this->SetTextColor(255, 255, 255);
        $this->Cell(140, 7, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(80, 7, utf8_decode("$ INGRESO QUEDANTE:  "), 1, 0, 'R', true);
        $this->Cell(25, 7, '$' . number_format($resta, 2, "."), 1, 0, 'C', true);
*/

    }

    function ingresosGastosS($gastos, $ingresos, $ingresosT, $gastosT, $mes)
    {
        $this->Ln(15);
        $this->SetTextColor(255, 255, 255);
        $this->SetFillColor(48, 149, 124);
        $this->SetFont('', 'B', 8);
        if (count($ingresos) == 0) {
            $this->Cell(150, 8, utf8_decode("¡NO HAY DATOS! --°0°--"), 0, 0, "R", false);
        } else {
            $this->Cell(50, 8, utf8_decode('INGRESOS EN EFECTIVO'), 1, 0, "C", true);
            $this->Ln();
            $this->Cell(10, 8, utf8_decode("#"), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('FECHA'), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('TOTAL'), 1, 0, "C", true);
            foreach ($ingresos as $K => $i) {
                $this->Ln();
                $this->SetTextColor(0, 0, 0);
                $this->SetFont('', '', 8);
                $this->Cell(10, 8, utf8_decode($K + 1), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($i['FECHA']->format('Y-m-d')), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($i['TOTAL']), 1, 0, "C", false);
            }
        }
        $this->Ln(); // Añadir un espacio entre las dos tablas

        $this->SetY(20); // Asegurarse de que la segunda tabla empiece en la posición deseada
        $this->SetTextColor(255, 255, 255);
        $this->SetFillColor(48, 149, 124);
        $this->SetFont('', 'B', 8);
        if (count($ingresosT) == 0) {
            $this->Cell(150, 8, utf8_decode("¡NO HAY DATOS! --°0°--"), 0, 0, "R", false);
        } else {
            $this->Ln(25);
            $this->Cell(55, 8, utf8_decode(''), 0, 0, "C", false);
            $this->Cell(50, 8, utf8_decode('INGRESOS EN TRANSFERENCIA'), 1, 0, "C", true);
            $this->Ln();
            $this->Cell(55, 8, utf8_decode(''), 0, 0, "C", false);

            $this->Cell(10, 8, utf8_decode("#"), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('FECHA'), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('TOTAL'), 1, 0, "C", true);
            foreach ($ingresosT as $K => $it) {
                $this->Ln();
                $this->SetTextColor(0, 0, 0);
                $this->SetFont('', '', 8);
                $this->Cell(55, 8, utf8_decode(''), 0, 0, "C", false);

                $this->Cell(10, 8, utf8_decode($K + 1), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($it['FECHA']->format('Y-m-d')), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($it['TOTAL']), 1, 0, "C", false);
            }
        }


        $this->AddPage();
        $this->Ln(15);
        $this->SetTextColor(255, 255, 255);
        $this->SetFillColor(48, 149, 124);
        $this->SetFont('', 'B', 8);
        if (count($gastos) == 0) {
            $this->Cell(150, 8, utf8_decode("¡NO HAY DATOS! --°0°--"), 0, 0, "R", false);
        } else {
            $this->Cell(50, 8, utf8_decode('INGRESOS EN EFECTIVO'), 1, 0, "C", true);
            $this->Ln();
            $this->Cell(10, 8, utf8_decode("#"), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('FECHA'), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('TOTAL'), 1, 0, "C", true);
            foreach ($gastos as $K => $g) {
                $this->Ln();
                $this->SetTextColor(0, 0, 0);
                $this->Cell(10, 8, utf8_decode($K + 1), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($g['COUNT_DESCRIPCION']), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($g['DESCRIPCION']), 1, 0, "C", false);
            }
            $this->Ln();
        }


        if (count($ingresosT) == 0) {
            $this->Cell(150, 8, utf8_decode("¡NO HAY DATOS! --°0°--"), 0, 0, "R", false);
        } else {
            $this->SetY(20);
            $this->Cell(50, 8, utf8_decode('INGRESOS EN TRANSFERENCIA'), 1, 0, "C", true);
            $this->Ln();
            $this->Cell(10, 8, utf8_decode("#"), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('FECHA'), 1, 0, "C", true);
            $this->Cell(20, 8, utf8_decode('TOTAL'), 1, 0, "C", true);
            $this->Ln();
            foreach ($ingresosT as $key => $it) {
                $this->SetX(90);
                $this->Cell(10, 8, utf8_decode($key + 1), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($it['FECHA']->format('Y-m-d')), 1, 0, "C", false);
                $this->Cell(20, 8, utf8_decode($it['TOTAL']), 1, 0, "C", false);
                $this->Ln();
            }
        }


    }


}


