<?php

namespace App\Controller;

use Fpdf\Fpdf;
use phpDocumentor\Reflection\Types\This;
use Prophecy\Doubler\Generator\TypeHintReference;

date_default_timezone_set('America/Mexico_City');

class PdfReportes extends Fpdf


{

    function generarReportes($gastos, $Dia, $resumenG, $resumenGT)

    {

        $sumaGeneral = 0;

        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(150, 7, utf8_decode("GASTOS DEL DÍA"), 0, 0, 'R', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '9');

        $this->Cell(150, 8, $Dia, 0, 0, 'R', false);
        $this->Ln(15);
        $sumaResumen = 0;
        $sumaResumenT = 0;
        if (count($resumenG) == 0) {

        } else {
            //$this->Cell(35, 10, utf8_decode('SI HAY DATOS'), 1, 0, 'C', true);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(28, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 8, utf8_decode('GASTOS EN EFECTIVO'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(28, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(15, 8, utf8_decode('#'), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode('TOTAL POR GASTO'), 1, 0, 'C', true);
            $this->Cell(50, 8, utf8_decode('DESCRIPCIÓN'), 1, 0, 'C', true);
            $this->Cell(40, 8, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont('helvetica', '', '9');

            foreach ($resumenG as $key => $r) {
                $this->SetFont('helvetica', '', '8');

                $this->Cell(28, 7, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(15, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($r['COUNT_DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(50, 7, utf8_decode($r['DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(40, 7, '$' . number_format($r['SUMA'], 2, "."), 1, 0, 'R', false);
                $sumaResumen += $r['SUMA'];
                $this->Ln();
            }
            $this->SetTextColor(255, 255, 255);
            $this->SetFont('helvetica', 'B', '8');

            $this->Cell(28, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(100, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->SetTextColor(0, 0, 0);

            $this->Cell(40, 7, '$' . number_format($sumaResumen, 2, "."), 1, 0, 'R', false);

        }

        $this->Ln(20);
        $this->SetFont('helvetica', 'B', '9');

        if (count($resumenGT) == 0) {

        } else {
            //$this->Cell(35, 10, utf8_decode('SI HAY DATOS'), 1, 0, 'C', true);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(0, 0, 0);

            $this->Cell(28, 8, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 8, utf8_decode('GASTOS EN TRANSFERENCIA'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);

            $this->Cell(28, 8, utf8_decode(''), 0, 0, 'C', false);

            $this->Cell(15, 8, utf8_decode('#'), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode('TOTAL POR GASTO'), 1, 0, 'C', true);
            $this->Cell(50, 8, utf8_decode('DESCRIPCIÓN'), 1, 0, 'C', true);
            $this->Cell(40, 8, utf8_decode('TOTAL'), 1, 0, 'C', true);

            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont('helvetica', '', '8');

            foreach ($resumenGT as $key => $gt) {
                $this->Cell(28, 8, utf8_decode(''), 0, 0, 'C', false);

                $this->Cell(15, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($gt['COUNT_DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(50, 7, utf8_decode($gt['DESCRIPCION']), 1, 0, 'C', false);
                $this->Cell(40, 7, '$' . number_format($gt['SUMA'], 2, "."), 1, 0, 'R', false);
                $sumaResumenT += $gt['SUMA'];
                $this->Ln();
            }
            $this->SetTextColor(255, 255, 255);
            $this->SetFont('helvetica', 'B', '9');
            $this->Cell(28, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(100, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->SetTextColor(0, 0, 0);

            $this->Cell(40, 7, '$' . number_format($sumaResumenT, 2, "."), 1, 0, 'R', false);

        }
        $this->Ln(20);


        if (count($gastos) == 0) {
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->Cell(195, 8, utf8_decode('SIN REGISTROS'), 1, 0, 'C', true);
        } else {
            $this->SetFillColor(48, 149, 124);

            $this->Cell(1, 8, utf8_decode(''), 0, 0, 'L', false);
            $this->Cell(193, 8, utf8_decode('GASTOS EN TRANSFERENCIA'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(1, 8, utf8_decode(''), 0, 0, 'L', false);

            $this->Cell(15, 8, utf8_decode('#'), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode('Gasto'), 1, 0, 'C', true);
            $this->Cell(22, 8, utf8_decode('Fecha.T'), 1, 0, 'C', true);
            $this->Cell(24, 8, utf8_decode('Hora T'), 1, 0, 'C', true);
            $this->Cell(32, 8, utf8_decode('Fecha M'), 1, 0, 'C', true);
            $this->Cell(30, 8, utf8_decode('Hora de M'), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode('Total Monto'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont('helvetica', '', '9');
            foreach ($gastos as $k => $g) {
                $sumaGeneral = $sumaGeneral + $g->getTotMon();
                $this->Cell(1, 8, utf8_decode(''), 0, 0, 'L', false);

                $this->Cell(15, 7, utf8_decode($k + 1), 1, 0, 'C', false);
                if (($g->getCveCatGast()) == null) {
                    $this->Cell(35, 7, utf8_decode(""), 1, 0, 'J', false);
                } else {
                    $this->Cell(35, 7, utf8_decode($g->getCveCatGast()->getDescripcion()), 1, 0, 'J', false);
                }
                $this->Cell(22, 7, utf8_decode($g->getFecMovGast()->format('d/m/Y')), 1, 0, 'J', false);
                $this->Cell(24, 7, utf8_decode($g->getHorMovGast()->format("H:i")), 1, 0, 'J', false);
                $this->Cell(32, 7, utf8_decode($g->getFecMov()->format('Y/m/d')), 1, 0, 'J', false);
                $this->Cell(30, 7, utf8_decode($g->getHorMov()->format('H:i')), 1, 0, 'J', false);
                $this->Cell(35, 7, utf8_decode($g->getTotMon()), 1, 0, 'R', false);
                $this->Ln();

            }
            $this->SetFont('helvetica', 'B', '9');
            $this->SetTextColor(255, 255, 255);
            $this->Cell(1, 8, utf8_decode(''), 0, 0, 'L', false);

            $this->Cell(158, 8, utf8_decode('TOTAL GASTOS:'), 1, 0, 'L', true);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(35, 8, '$' . number_format($sumaGeneral, 2, "."), 1, 0, 'R', false);

            $this->Ln(10);

        }
    }


    function BuffetMes($res)
    {

        $sumaGeneral = 0;
        $sumatotal = 0;

        $this->SetFont('helvetica', 'B', '10');
        $this->Cell(150, 7, utf8_decode("REPORTE DE BUFFET"), 0, 0, 'R', false);
        $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);
        $this->Ln(30);
        $this->Cell(25, 8, utf8_decode("Fecha"), 1, 0, 'L', false);
        $this->Cell(20, 8, utf8_decode("Total"), 1, 0, 'L', false);
        $this->Cell(20, 8, utf8_decode(""), 0, 0, 'L', false);
        $this->Cell(20, 8, utf8_decode("Fecha"), 1, 0, 'L', false);
        $this->Cell(20, 8, utf8_decode("Buffet"), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode("Buffet CEEPAM"), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode("Buffet UTM"), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode("Buffet Niños"), 1, 0, 'L', false);
        $this->Cell(25, 8, utf8_decode("Total"), 1, 0, 'L', false);


        $this->Ln();
        foreach ($res as $k => $i) {
            $this->SetFont('helvetica', '', '8');
            $this->Cell(25, 8, utf8_decode($i['fecMov']->format('d/m/Y')), 1, 0, 'L', false);
            $this->Cell(20, 8, utf8_decode($i['total']), 1, 0, 'C', false);
            $this->Cell(20, 8, utf8_decode(""), 0, 0, 'L', false);

            if ($i == 0) {
                $this->Cell(20, 8, utf8_decode($i['fecMov']->format('d/m/Y')), 1, 0, 'L', false);
                $this->Cell(20, 8, utf8_decode("0"), 1, 0, 'L', false);

            } else {

                $this->Cell(20, 8, utf8_decode($i['fecMov']->format('d/m/Y')), 1, 0, 'L', false);
                $this->Cell(20, 8, utf8_decode($i['categoria']), 1, 0, 'L', false);
                $this->Cell(30, 8, utf8_decode($i['categoria']), 1, 0, 'L', false);
                $this->Cell(30, 8, utf8_decode($i['categoria']), 1, 0, 'L', false);
                $this->Cell(30, 8, utf8_decode($i['categoria']), 1, 0, 'L', false);
                $this->Cell(25, 8, utf8_decode($i['total']), 1, 0, 'L', false);
                $this->Ln();
            }
        }


        /*
        $this->Ln(3);
        $this->Cell(25, 8, utf8_decode(""), 0, 0, 'L', false);
        $this->Cell(20, 8, utf8_decode("TOTAL:"), 1, 0, 'L', false);
        $this->Cell(20, 8, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(20, 8, utf8_decode(""), 0, 0, 'C', false);
        $this->Cell(20, 8, utf8_decode('TOTAL:'), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode('TOTAL:'), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode('TOTAL:'), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode('TOTAL:'), 1, 0, 'L', false);
        $this->Cell(30, 8, utf8_decode('TOTAL:'), 1, 0, 'L', false);
        $this->Cell(25, 8, utf8_decode('TOTAL:'), 1, 0, 'L', false);
        */


    }

    function Header()
    {
        $this->Image('assets/media/logos/membrete.png', 0, 0, 230);

        $this->Ln(20);
    }

    function BuffetDia($ingresosBuffet, $hoy, $detallesMenu)
    {


        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("REPORTE BUFFET DEL DÍA:"), 0, 0, 'R', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '10');
        $this->Cell(0, 8, ($hoy), 0, 0, 'R', false);
        $this->Ln();


        $fecha = "";
        $auxDatos = "";

        if (count($ingresosBuffet) == 0) {

            $this->SetXY(50, 100);
            $this->Image('assets/media/logos/adv.png', 65, 70, 100);
            $this->SetXY(50, 180);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(135, 163, 241);

            $this->Cell(120, 9, utf8_decode("NO HAY NINGÚN REGISTRO EN ESTA FECHA"), 1, 0, 'C', true);

        } else {

            $this->SetTextColor(0, 0, 0);
            $this->Ln();
            $this->SetX(20);
            $this->SetFont('helvetica', '', '10');
            $datos = [];
            foreach ($ingresosBuffet as $ib) {
                $fecha = $ib['FECHA']->format('d/m/Y');
                $tipo_menu = $ib['TIPO_DE_MENU'];
                $nombre_menu = $ib['NOM_MENU'];
                $total = $ib['TOTAL'];
                if (!isset($datos[$fecha][$tipo_menu])) {
                    $datos[$fecha][$tipo_menu] = [
                        'NOM_MENU' => $nombre_menu,
                        'TOTAL' => $total,
                    ];
                } else {
                    $datos[$fecha][$tipo_menu]['TOTAL'] += $total;
                }
                $this->Ln(5);
            }

            foreach ($datos as $key => $d) {
                $this->SetX(1);
                $this->SetFont("", "B", "20");
                $this->SetTextColor(54, 153, 255);
                $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
                $this->Ln(6);
                $this->SetTextColor(0, 0, 0);
                $this->Cell(0, 2, utf8_decode($fecha), 0, 0, 'C', false);
                $this->Ln(10);
                $this->SetTextColor(54, 153, 255);

                $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);

                $this->Cell(240, 8, utf8_decode($key), 0, 0, 'C', false); // La altura de la celda se calcula en función del número de tipos de menú
                $totalPorBuffet = 0;
                $totalGeneral = 0;
                $this->Ln(20);
                $this->SetX(20);
                $this->SetFont("", "B", 12);
                $this->SetTextColor(255, 255, 255);
                $this->SetFillColor(48, 149, 124);
                $this->Cell(16, 8, utf8_decode("#"), 1, 0, 'C', true);
                $this->Cell(60, 8, utf8_decode("BUFFET VENDIDO"), 1, 0, 'C', true);
                $this->Cell(45, 8, utf8_decode("TOTAL POR BUFFET"), 1, 0, 'C', true);
                $this->Cell(45, 8, utf8_decode("TOTAL GENERAL"), 1, 0, 'C', true);
                $this->SetTextColor(0, 0, 0);
                $this->Ln();
                $this->SetFont("", "B", "10");


                foreach ($d as $key => $dd) {
                    $totalPorBuffet += $dd['TOTAL'];
                }
                $this->Cell(141, 8, "", 0, 0, 'C', false);
                $this->Cell(45, count($d) * 8, ($totalPorBuffet), 1, 0, 'C', false);

                foreach ($d as $key => $ddd) {
                    $this->SetX(20);
                    $this->SetFont("", "B", 10);
                    $this->Cell(16, 8, utf8_decode($key), 1, 0, 'C', false);
                    $this->SetFont("", "", 10);
                    // $this->Cell(60, 8, utf8_decode($ddd['HORA']), 1, 0, 'J', false);

                    $this->Cell(60, 8, utf8_decode($ddd['NOM_MENU']), 1, 0, 'J', false);
                    $this->Cell(45, 8, utf8_decode($ddd['TOTAL']), 1, 0, 'C', false);
                    $this->Ln();
                }
            }
        }
        $this->Ln(170);

        if (count($detallesMenu) == 0) {

        } else {
            $this->SetTextColor(255, 255, 255);
            $this->Cell(30, 8, "", 0, 0, 'C', false);
            $this->Cell(15, 8, "#", 1, 0, 'C', true);
            $this->Cell(30, 8, "FECHA", 1, 0, 'C', true);
            $this->Cell(30, 8, "HORA", 1, 0, 'C', true);
            $this->Cell(50, 8, "NOMBRE DEL MENU", 1, 0, 'C', true);
            $this->Cell(30, 8, "PRECIO", 1, 0, 'C', true);

            $this->Ln();
            $this->SetTextColor(0, 0, 0);

            $datos = [];
            $total = 0;
            foreach ($detallesMenu as $key => $dm) {
                $fecha = $dm['FECHA']->format('d/m/Y');
                $hora = $dm['HORA']->format('H:i:s');
                $nombre_menu = $dm['NOMBRE_MENU'];
                $precio = $dm['PRECIO'];
                $this->Cell(30, 8, "", 0, 0, 'C', false);
                $this->Cell(15, 8, $key + 1, 1, 0, 'C', false);
                $this->Cell(30, 8, $fecha, 1, 0, 'C', false);
                $this->Cell(30, 8, $hora, 1, 0, 'C', false);
                $this->Cell(50, 8, utf8_decode($nombre_menu), 1, 0, 'J', false);
                $this->Cell(30, 8, "$" . $precio, 1, 0, 'C', false);
                $this->Ln();
                $total += $precio;

            }
            // Imprimir el total en una celda adicional

            $this->SetFont("", "B", 12);
            $this->SetTextColor(255, 255, 255);
            $this->Cell(30, 8, "", 0, 0, 'C', false);
            $this->Cell(125, 8, "Total:", 1, 0, 'R', true);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(30, 8, "$" . number_format($total, 2), 1, 0, 'C', false);

        }

    }


    function imprimirCorteGeneral($hoy, $ingresos, $ingresos2, $gastosEf, $gastosT)
    {
        /**
         * INICIA EL ENCABEZADO
         */

        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("GASTOS E INGRESOS DEL DÍA:"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '12');
        $this->Cell(0, 8, ($hoy), 0, 0, 'C', false);

        $sumaIngresos = 0;
        $sumaIngresos2 = 0;
        $sumaGE = 0;
        $sumaGT = 0;

        $restaE = 0;
        $restaT = 0;

        $totalE = 0;
        $totalT = 0;
        $this->Ln();
        if (count($ingresos) == 0) {

        } else {
            $this->Ln();
            $this->SetFont("", "B", 9);
            $this->SetFillColor(48, 149, 124);
            $this->SetX(10);
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(155, 7, utf8_decode('INGRESOS EN EFECTIVO'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(30, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 7, utf8_decode('N°'), 1, 0, 'C', true);
            $this->Cell(30, 7, utf8_decode('TICKET'), 1, 0, 'C', true);
            // $this->Cell(30, 7, utf8_decode('FECHA SERVICIO'), 1, 0, 'C', true);
            //$this->Cell(30, 7, utf8_decode('SUBTOTAL'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('FECHA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('HORA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            //$this->Cell(35, 7, utf8_decode('TOTAL GASTO'), 1, 0, 'C', true);

            $this->Ln();
            foreach ($ingresos as $key => $i) {
                $this->SetTextColor(0, 0, 0);
                $this->SetFont("", "", 9);
                $this->Cell(30, 7, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(30, 7, utf8_decode($i['N_TICKET']), 1, 0, 'C', false);
                //  $this->Cell(30, 7, utf8_decode($i['FECHA_SERVICIO']->format('Y-m-d')), 1, 0, 'C', false);
                //$this->Cell(30, 7, '$' . number_format($i['TOTAL_ESPERADO'], 2, "."), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($i['FECHA_INGRESO']->format('Y-m-d')), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($i['HORA_ING']->format('H:i:s')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($i['TOTAL_INGRESOS'], 2, "."), 1, 0, 'C', false);


                /*$this->Cell(35, 7, utf8_decode($i['TOTAL_INGRESOS']), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($i['TOTAL_GASTOS']), 1, 0, 'C', false);*/
                $sumaIngresos += $i['TOTAL_INGRESOS'];
                $this->Ln();
            }
            $this->SetFont("", "B", 9);
            $this->Cell(30, 7, utf8_decode(' '), 0, 0, 'C', false);
            $this->Cell(120, 7, utf8_decode('TOTAL: '), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaIngresos, 2, "."), 1, 0, 'C', false);


        }

        $this->Ln(15);
        if (count($ingresos2) == 0) {

        } else {
            $this->SetFont("", "B", 9);
            $this->SetFillColor(48, 149, 124);
            $this->SetX(10);
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(155, 7, utf8_decode('INGRESOS EN TRANSFERENCIA'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(30, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 7, utf8_decode('N°'), 1, 0, 'C', true);
            $this->Cell(30, 7, utf8_decode('TICKET'), 1, 0, 'C', true);
            // $this->Cell(30, 7, utf8_decode('FECHA SERVICIO'), 1, 0, 'C', true);
            //$this->Cell(30, 7, utf8_decode('SUBTOTAL'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('FECHA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('HORA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            //$this->Cell(35, 7, utf8_decode('TOTAL GASTO'), 1, 0, 'C', true);

            $this->Ln();
            foreach ($ingresos2 as $key => $i2) {
                $this->SetTextColor(0, 0, 0);
                $this->SetFont("", "", 9);
                $this->Cell(30, 7, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(30, 7, utf8_decode($i2['N_TICKET']), 1, 0, 'C', false);
                //  $this->Cell(30, 7, utf8_decode($i['FECHA_SERVICIO']->format('Y-m-d')), 1, 0, 'C', false);
                //$this->Cell(30, 7, '$' . number_format($i['TOTAL_ESPERADO'], 2, "."), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($i2['FECHA_INGRESO']->format('Y-m-d')), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($i2['HORA_ING']->format('H:i:s')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($i2['TOTAL_INGRESOS'], 2, "."), 1, 0, 'C', false);


                /*$this->Cell(35, 7, utf8_decode($i['TOTAL_INGRESOS']), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($i['TOTAL_GASTOS']), 1, 0, 'C', false);*/
                $sumaIngresos2 += $i2['TOTAL_INGRESOS'];
                $this->Ln();
            }
            $this->SetFont("", "B", 9);
            $this->Cell(30, 7, utf8_decode(' '), 0, 0, 'C', false);
            $this->Cell(120, 7, utf8_decode('TOTAL: '), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaIngresos2, 2, "."), 1, 0, 'C', false);

        }


        $this->Ln(10);

        if (count($gastosEf) == 0) {

        } else {
            $this->AddPage();
            $this->Ln(5);
            $this->SetFont("", "B", 8);

            $this->SetTextColor(0, 0, 0);
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(175, 7, utf8_decode('GASTOS EN EFECTIVO'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 7, utf8_decode('N°'), 1, 0, 'C', true);
            $this->Cell(50, 7, utf8_decode('NOMBRE DEL ÁRTICULO '), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('FECHA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('HORA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont("", "", 8);
            foreach ($gastosEf as $key => $ge) {
                $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(50, 7, utf8_decode($ge['ARTICULO']), 1, 0, 'L', false);
                $this->Cell(35, 7, utf8_decode($ge['FECHA']->format('d-m-Y')), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($ge['HORA']->format('H:i:s:m')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($ge['TOTAL'], 2, "."), 1, 0, 'C', false);
                $sumaGE += $ge['TOTAL'];

                $this->Ln();
            }
            $this->SetFont("", "B", 8);

            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 7, utf8_decode('TOTAL:'), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaGE, 2, "."), 1, 0, 'C', false);

        }


        $this->Ln(10);

        if (count($gastosT) == 0) {

        } else {
            $this->Ln(5);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(175, 7, utf8_decode('GASTOS EN TRANSFERENCIA'), 1, 0, 'C', false);
            $this->Ln();
            $this->SetTextColor(255, 255, 255);
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 7, utf8_decode('N°'), 1, 0, 'C', true);
            $this->Cell(50, 7, utf8_decode('NOMBRE DEL ÁRTICULO '), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('FECHA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('HORA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetTextColor(0, 0, 0);
            $this->SetFont("", "", 8);
            foreach ($gastosT as $ky => $gT) {
                $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($ky + 1), 1, 0, 'C', false);
                $this->Cell(50, 7, utf8_decode($gT['ARTICULO']), 1, 0, 'L', false);
                $this->Cell(35, 7, utf8_decode($gT['FECHA']->format('d-m-Y')), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($gT['HORA']->format('H:i:s:m')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($gT['TOTAL'], 2, "."), 1, 0, 'C', false);
                $sumaGT += $gT['TOTAL'];

                $this->Ln();
            }
            $this->SetFont("", "B", 8);

            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 7, utf8_decode('TOTAL:'), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaGT, 2, "."), 1, 0, 'C', false);

        }
        $this->Ln(10);
        if ($restaE == 0 || $restaT == 0) {

        } else {

            $restaE = $sumaIngresos - $sumaGE;
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 7, utf8_decode('TOTAL RESTANTE EN EFECTIVO:'), 0, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($restaE, 2, "."), 1, 0, 'C', false);

            $this->Ln(10);
            $restaT = $sumaIngresos2 - $sumaGT;
            $this->Cell(20, 7, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(140, 7, utf8_decode('TOTAL RESTANTE EN TRANSFERENCIA:'), 0, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($restaT, 2, "."), 1, 0, 'C', false);


        }

    }


    function corteDelDiaTicket($ticketPagado, $hoy, $ingresos)
    {
        /**
         * INICIA EL ENCABEZADO
         */

        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("RESUMEN DE REPORTE GENERAL:"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '12');
        $this->Cell(0, 8, ($hoy), 0, 0, 'C', false);
        $this->Ln(10);
        $sumaSubtotal = 0;
        $sumaIngresos = 0;
        $sumEfectivo = 0;
        $sumTransferencia = 0;
        if (count($ticketPagado) == 0) {
            $this->Cell(0, 7, utf8_decode("No hay tickets"), 0, 0, 'C', false);

        } else {
            $this->SetFont("", "B", 8);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(10, 8, utf8_decode("#"), 1, 0, 'C', true);
            $this->Cell(25, 8, utf8_decode("N° TICKET"), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode("FECHA SERVICIO"), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode("$ SUBTOTAL"), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode("FECHA PAGO"), 1, 0, 'C', true);
            $this->Cell(30, 8, utf8_decode("$ TOTAL"), 1, 0, 'C', true);
            $this->Cell(25, 8, utf8_decode("MODO PAGO"), 1, 0, 'C', true);

            $this->Ln();
            $this->SetTextColor(0, 0, 0);

            $this->SetFont("", "", 8);

            foreach ($ticketPagado as $key => $tp) {
                $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(10, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(25, 7, utf8_decode($tp['IDE_SERVICIO']), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($tp['FECHA_MOV']->format('Y-m-d')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($tp['TOTAL_PAGO'], 2, "."), 1, 0, 'C', false);

                if ($tp['FECHA_INGRESOS'] == null) {
                    $this->Cell(35, 7, utf8_decode('SIN FECHA'), 1, 0, 'C', false);

                } else {
                    $this->Cell(35, 7, utf8_decode($tp['FECHA_INGRESOS']->format('Y-m-d')), 1, 0, 'C', false);
                }

                if ($tp['TOTAL_RECIBIDO'] == null) {
                    $this->Cell(30, 7, utf8_decode('NO HAY PAGO'), 1, 0, 'C', false);

                } else {
                    $this->Cell(30, 7, ('$' . $tp['TOTAL_RECIBIDO']), 1, 0, 'C', false);
                    //$this->Cell(30, 7, '$' . number_format($tp['TOTAL_RECIBIDO'], 2, "."), 1, 0, 'C', false);

                }


                $this->Cell(25, 7, utf8_decode($tp['MODO_PAGO']), 1, 0, 'C', false);


                $sumaSubtotal += $tp['TOTAL_PAGO'];
                if ($tp['TOTAL_RECIBIDO'] != null) {
                    $sumaIngresos += floatval($tp['TOTAL_RECIBIDO']);
                }

                $this->Ln();
            }

            foreach ($ingresos as $key => $i) {
                if ($i->getCveModPag()->getIdeModPag() == 1) { // EFECTIVO
                    $sumEfectivo += $i->getTotal();
                } else { // TRANSFERENCIA
                    $sumTransferencia += $i->getTotal();
                }
            }
            $this->SetFont("", "B", 8);
            $this->Cell(10, 7, utf8_decode(" "), 0, 0, 'R', false);
            $this->Cell(70, 7, utf8_decode("SUBTOTAL: "), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaSubtotal, 2, "."), 1, 0, 'C', false);


            $this->Cell(35, 7, utf8_decode("TOTAL: "), 1, 0, 'R', false);
            $this->Cell(30, 7, '$' . number_format($sumaIngresos, 2, "."), 1, 0, 'C', false);


            $this->Ln(10);
            $this->Cell(80, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(70, 7, utf8_decode("TOTAL INGRESO EN EFECTIVO: "), 1, 0, 'R', false);

            $this->Cell(30, 7, '$' . number_format($sumEfectivo, 2, "."), 1, 0, 'C', false);
            $this->Ln(20);
            $this->Cell(80, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(70, 7, utf8_decode("TOTAL INGRESO EN TRANSFERENCIA: "), 1, 0, 'R', false);

            $this->Cell(30, 7, '$' . number_format($sumTransferencia, 2, "."), 1, 0, 'C', false);

        }

    }

    function corteDiaTicket($ticketPagado, $hoy, $ingresos)
    {
        /**
         * INICIA EL ENCABEZADO
         */

        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("RESUMEN DE REPORTE GENERAL:"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '12');
        $this->Cell(0, 8, ($hoy), 0, 0, 'C', false);
        $this->Ln(10);
        $sumaSubtotal = 0;
        $sumaIngresos = 0;
        $sumEfectivo = 0;
        $sumTransferencia = 0;
        if (count($ticketPagado) == 0) {
            $this->Cell(0, 7, utf8_decode("No hay tickets"), 0, 0, 'C', false);

        } else {
            $this->SetFont("", "B", 8);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(10, 8, utf8_decode("#"), 1, 0, 'C', true);
            $this->Cell(20, 8, utf8_decode("N° TICKET"), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode("FECHA SERVICIO"), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode("$ SUBTOTAL"), 1, 0, 'C', true);
            $this->Cell(35, 8, utf8_decode("FECHA PAGO"), 1, 0, 'C', true);
            $this->Cell(25, 8, utf8_decode("$ TOTAL"), 1, 0, 'C', true);
            $this->Cell(30, 8, utf8_decode("MODO PAGO"), 1, 0, 'C', true);

            //$this->Cell(20, 8, utf8_decode("$ MODO PAGO"), 1, 0, 'C', true);

            $this->Ln();
            $this->SetTextColor(0, 0, 0);

            $this->SetFont("", "", 8);

            foreach ($ticketPagado as $key => $tp) {
                $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(10, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($tp['IDE_SERVICIO']), 1, 0, 'C', false);
                $this->Cell(35, 7, utf8_decode($tp['FECHA_MOV']->format('d-m-Y')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($tp['TOTAL_PAGO'], 2, "."), 1, 0, 'C', false);

                if ($tp['FECHA_INGRESOS'] == null) {
                    $this->SetFont("", "B", 8);
                    $this->SetTextColor(0, 0, 0);
                    $this->SetFillColor(219, 237, 0);
                    $this->Cell(35, 7, utf8_decode('SIN FECHA'), 1, 0, 'C', true);

                } else {
                    $this->SetFont("", "", 8);
                    $this->Cell(35, 7, utf8_decode($tp['FECHA_INGRESOS']->format('d-m-Y')), 1, 0, 'C', false);
                }

                if ($tp['TOTAL_RECIBIDO'] == null) {
                    $this->SetFont("", "B", 8);
                    $this->Cell(25, 7, utf8_decode('NO HAY PAGO'), 1, 0, 'C', true);

                } else {
                    $this->SetFont("", "", 8);
                    $this->Cell(25, 7, ('' . $tp['TOTAL_RECIBIDO']), 1, 0, 'C', false);
                    //$this->Cell(30, 7, '$' . number_format($tp['TOTAL_RECIBIDO'], 2, "."), 1, 0, 'C', false);

                }
                $this->Cell(30, 7, utf8_decode($tp['MODO_PAGO']), 1, 0, 'C', false);


                $sumaSubtotal += $tp['TOTAL_PAGO'];
                if ($tp['TOTAL_RECIBIDO'] != null) {
                    $sumaIngresos += floatval($tp['TOTAL_RECIBIDO']);
                }
                $this->Ln();
            }


            foreach ($ingresos as $key => $i) {
                if ($i->getCveModPag()->getIdeModPag() == 1) { // EFECTIVO
                    $sumEfectivo += $i->getTotal();
                } else { // TRANSFERENCIA
                    $sumTransferencia += $i->getTotal();
                }
            }
            $this->SetFont("", "B", 8);

            $this->Cell(10, 7, utf8_decode(" "), 0, 0, 'R', false);
            $this->Cell(65, 7, utf8_decode("SUBTOTAL: "), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaSubtotal, 2, "."), 1, 0, 'C', false);


            $this->Cell(35, 7, utf8_decode("TOTAL: "), 1, 0, 'R', false);
            $this->Cell(25, 7, '$' . number_format($sumaIngresos, 2, "."), 1, 0, 'C', false);

            $this->Ln(10);
            $this->Cell(75, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(70, 7, utf8_decode("TOTAL INGRESO EN EFECTIVO: "), 1, 0, 'R', false);

            $this->Cell(25, 7, '$' . number_format($sumEfectivo, 2, "."), 1, 0, 'C', false);
            $this->Ln(20);
            $this->Cell(75, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(70, 7, utf8_decode("TOTAL INGRESO EN TRANSFERENCIA: "), 1, 0, 'R', false);

            $this->Cell(25, 7, '$' . number_format($sumTransferencia, 2, "."), 1, 0, 'C', false);


        }

    }

    function CorteMes($ticketPagado,)
    {

        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("RESUMEN DE REPORTE GENERAL:"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '12');
        //  $this->Cell(0, 8, (), 0, 0, 'C', false);
        $this->Ln(10);
        $this->SetFont('helvetica', '', '8');

        $sumaTransferencia = 0;
        $sumaEfectivo = 0;
        $total = 0;
        if (count($ticketPagado) == 0) {

        } else {
            $this->SetFont('helvetica', 'B', '8');

            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(10, 7, utf8_decode(""), 1, 0, 'C', true);
            $this->Cell(20, 7, utf8_decode('SERVICO'), 1, 0, 'C', true);
            $this->Cell(20, 7, utf8_decode('RECIBO'), 1, 0, 'C', true);
            $this->Cell(30, 7, utf8_decode('FECHA'), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode('TOTAL'), 1, 0, 'C', true);
            $this->Cell(30, 7, utf8_decode('MODO PAGO'), 1, 0, 'C', true);
            $this->Ln();
            foreach ($ticketPagado as $key => $t) {
                $this->SetFont("", "", 8);
                $this->SetTextColor(0, 0, 0);


                $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(10, 7, utf8_decode($key + 1), 1, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($t->getCveSerCue()->getIdeSerCue()), 1, 0, 'C', false);
                $this->Cell(20, 7, utf8_decode($t->getRecibo()), 1, 0, 'C', false);
                $this->Cell(30, 7, utf8_decode($t->getFecMov()->format('Y-m-d')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . number_format($t->getTotal(), 2, "."), 1, 0, 'C', false);
                $this->Cell(30, 7, utf8_decode($t->getCveModPag()->getModoPago()), 1, 0, 'C', false);

                if ($t->getCveModPag()->getIdeModPag() == 1) { // EFECTIVO

                    $sumaEfectivo += $t->getTotal();
                } else { // TRANSFERENCIA
                    $sumaTransferencia += $t->getTotal();
                }
                $total += $t->getTotal();

                /*
                $this->Cell(35, 7, utf8_decode($t['FECHA_MOV']->format('d-m-Y')), 1, 0, 'C', false);
                $sumaSubTotal += $t['TOTAL_PAGO'];*/
                $this->Ln();

            }
            $this->SetFont('helvetica', 'B', '8');


            $this->Ln(10);
            $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);

            $this->Cell(80, 7, utf8_decode("SUMA TRANSFERENCIA"), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaTransferencia, 2, "."), 1, 0, 'C', false);
            $this->Ln();
            $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);

            $this->Cell(80, 7, utf8_decode("SUMA EFECTIVO"), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . number_format($sumaEfectivo, 2, "."), 1, 0, 'C', false);

            $this->Ln(10);

            $this->Cell(10, 7, utf8_decode(""), 0, 0, 'R', false);

            $this->Cell(80, 7, utf8_decode("SUMA TOTAL"), 1, 0, 'R', false);

            $this->Cell(35, 7, '$' . number_format($total, 2, "."), 1, 0, 'C', false);

        }
        $this->Ln(10);

    }

    function imprimirCorteGeneraDia($corteResumenDia, $hoy, $gastosDia)
    {
        /**
         * INICIA EL ENCABEZADO
         */

        $this->SetFont('helvetica', 'B', '15');
        $this->SetY(30);
        $this->Cell(0, 7, utf8_decode("GASTOS E INGRESOS DEL DÍA:"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('helvetica', 'B', '12');
        $this->Cell(0, 7, utf8_decode($hoy), 0, 0, 'C', false);
        $this->SetFont('helvetica', 'B', '8');
        $this->SetTextColor(255, 255, 255);
        $this->SetFillColor(48, 149, 124);
        $this->Ln(10);
        $rsetante = 0;
        $sumaIngresos = 0;

// Tabla de corte de resumen del día
        if (count($corteResumenDia) == 0) {
            $this->Cell(0, 7, utf8_decode("NO HAY DATOS POR MOSTRAR:"), 0, 0, 'C', false);
        } else {
            $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(20, 7, utf8_decode("#"), 1, 0, 'C', true);
            /* $this->Cell(35, 7, utf8_decode("FECHA DEL SERVICIO "), 1, 0, 'C', true);
             $this->Cell(35, 7, utf8_decode("HORA DEL SERVICIO"), 1, 0, 'C', true);
             $this->Cell(25, 7, utf8_decode("SUBTOTAL"), 1, 0, 'C', true);
             $this->Cell(35, 7, utf8_decode("TOTAL DEL GASTO"), 1, 0, 'C', true);*/
            $this->Cell(30, 7, utf8_decode("N° SERVICIO"), 1, 0, 'C', true);
            $this->Cell(45, 7, utf8_decode("FECHA DE INGRESO"), 1, 0, 'C', true);
            $this->Cell(30, 7, utf8_decode("HORA DE PAGO"), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode("TOTAL"), 1, 0, 'C', true);

            $this->SetFont('', '', '8');
            $this->SetTextColor(0, 0, 0);

            $this->Ln();
            foreach ($corteResumenDia as $k => $cr) {
                $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(20, 7, utf8_decode($k + 1), 1, 0, 'C', false);
                $this->Cell(30, 7, utf8_decode($cr['IDE_SERVICIO']), 1, 0, 'C', false);
                $this->Cell(45, 7, utf8_decode($cr['FECHA_INGRESO']->format('Y-m-d')), 1, 0, 'C', false);
                $this->Cell(30, 7, utf8_decode($cr['HORA_MOV']->format('H:i:s')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . " " . number_format($cr['TOTAL_INGRESO'], 2, "."), 1, 0, 'C', false);

                $sumaIngresos += $cr['TOTAL_INGRESO'];
                $this->Ln();
            }
            $this->SetFont("", "B", 8);
            $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(125, 7, utf8_decode("TOTAL: "), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . " " . number_format($sumaIngresos, 2, "."), 1, 0, 'C', false);

        }

        $this->Ln(15);
        $totalG = 0;

        if (count($gastosDia) == 0) {
            // No hay datos por mostrar
        } else {
            $this->AddPage();

            $this->SetFont("", "B", 8);
            $this->SetTextColor(0, 0, 0);
            $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(160, 7, utf8_decode("GASTOS TOTALES"), 1, 0, 'C', false);
            $this->Ln();
            $this->SetFont("", "B", 8);
            $this->SetTextColor(255, 255, 255);
            $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(20, 7, utf8_decode("N° "), 1, 0, 'C', true);
            $this->Cell(65, 7, utf8_decode("NOMBRE DEL GASTO"), 1, 0, 'C', true);
            $this->Cell(40, 7, utf8_decode("FECHA "), 1, 0, 'C', true);
            $this->Cell(35, 7, utf8_decode("TOTAL"), 1, 0, 'C', true);
            $this->Ln();
            $this->SetFont("", "", 8);
            $this->SetTextColor(0, 0, 0);

            foreach ($gastosDia as $k => $g) {

                $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
                $this->Cell(20, 7, utf8_decode($k + 1), 1, 0, 'C', false);
                $this->Cell(65, 7, utf8_decode($g['NOMBRE']), 1, 0, 'L', false);
                $this->Cell(40, 7, utf8_decode($g['FECHA_GASTO']->format('Y-m-d')), 1, 0, 'C', false);
                $this->Cell(35, 7, '$' . " " . number_format($g['TOTAL_GASTO'], 2, "."), 1, 0, 'C', false);
                $totalG += $g['TOTAL_GASTO'];
                $this->Ln();
            }
            $this->SetFont("", "B", 8);
            $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
            $this->Cell(125, 7, utf8_decode("TOTAL: "), 1, 0, 'R', false);
            $this->Cell(35, 7, '$' . " " . number_format($totalG, 2, "."), 1, 0, 'C', false);
        }
        $this->Ln(15);
        $this->Cell(25, 7, utf8_decode(""), 0, 0, 'R', false);
        $rsetante = $sumaIngresos - $totalG;
        $this->Cell(125, 7, utf8_decode("RESTANTE TOTAL POR DÍA: "), 1, 0, 'R', false);
        $this->Cell(35, 7, '$' . " " . number_format($rsetante, 2, "."), 1, 0, 'C', false);

    }


    function ingresosGastos($resumenG, $ingresosE)
    {
        $this->SetFont('helvetica', 'B', '15');
        $this->Cell(0, 7, utf8_decode("GASTOS DEL MES"), 0, 0, 'C', false);
        $this->Ln(10);
        $this->SetTextColor(255, 255, 255);
        $this->SetFillColor(48, 149, 124);

        $sumaGastoEfectivo = 0;

        if (count($resumenG) == 0 || count($ingresosE) == 0) {
            $this->Cell(0, 7, utf8_decode("NO HAY DATOS"), 0, 0, 'C', false);

        } else {
            $this->Cell(5, 7, utf8_decode(''), 0, 0, 'L', false);
            $this->Cell(80, 7, utf8_decode('GASTOS EN EFECTIVO'), 1, 0, 'C', true);
            $this->Ln();
            $this->SetFont('helvetica', 'B', 10);
            $this->Cell(5, 7, utf8_decode(''), 0, 0, 'L', false);
            $this->Cell(10, 7, utf8_decode('#'), 1, 0, 'C', true);
            $this->SetFont('helvetica', 'B', 8);
            $this->Cell(10, 7, utf8_decode('N°. G'), 1, 0, 'C', true);
            $this->Cell(40, 7, utf8_decode('Descripción del gasto'), 1, 0, 'C', true);
            $this->Cell(20, 7, utf8_decode(' $ '), 1, 0, 'C', true);

            foreach ($resumenG as $k => $g) {
                $this->SetTextColor(0, 0, 0);
                $this->SetFont('helvetica', '', 8);
                $this->Ln();
                $this->Cell(5, 7, '', 0, 0, 'R', false);
                $this->Cell(10, 7, utf8_decode($k + 1), 1, 0, 'C', false);
                $this->Cell(10, 7, utf8_decode($g['COUNT_DESCRIPCION']), 1, 0, 'C', false);
                $this->SetFont('helvetica', '', 6);
                $this->Cell(40, 7, utf8_decode($g['DESCRIPCION']), 1, 0, 'L', false);
                $this->SetFont('helvetica', '', 8);
                $this->Cell(20, 7, utf8_decode('$' . ' ' . $g['SUMA']), 1, 0, 'R', false);
                $sumaGastoEfectivo += $g['SUMA'];
            }
            $this->SetY(50);
            foreach ($ingresosE as $ky => $i) {
                $this->Ln();
                $this->Cell(100, 7, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(10, 7, utf8_decode($ky + 1), 1, 0, 'C', false);

            }
        }
    }

}

