<?php

namespace App\Controller;

use Fpdf\Fpdf;

date_default_timezone_set('America/Mexico_City');

class PdfReservacion extends Fpdf
{
    function Header()
    {
        $this->Image('assets/media/logos/memCom.png', 0, 0, 216);

        $this->Ln(20);
    }

    function pdfReservas($datos)
    {
        $this->SetFont('helvetica', 'B', 15);


        foreach ($datos as $d) {


            $this->Ln();
            $this->SetY(30);
            $this->SetFillColor(255, 255, 255);
            $this->MultiCell(195, 80, "", 1, 'J', true); // Crear celda con bordes
            $this->SetY(40);
            $this->SetFont('helvetica', 'B', 10);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->SetY(30);
            $this->Cell(195, 7, utf8_decode('COMPROBANTE DE RESERVACIÓN'), 1, 0, 'C', true);
            $this->SetTextColor(0, 0, 0);
            $this->SetFont('helvetica', '', 10);
            $this->SetFont('helvetica', 'B', 10);

            $this->SetY(45);
            $this->Cell(47, 7, utf8_decode('Fecha en la que se reservo'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecMov()->format('d')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecMov()->format('m')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecMov()->format('Y')), 0, 0, 'C', false);

            $this->SetY(45);
            $this->SetFont('helvetica', 'B', 10);
            $this->Cell(142, 7, utf8_decode('Fecha de reservación'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecReserva()->format('d')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecReserva()->format('m')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecReserva()->format('Y')), 0, 0, 'C', false);


            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(10, 7, utf8_decode('Nombre de la persona: '), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(150, 7, utf8_decode($d->getNombre() . ' ' . $d->getApellidoPat() . ' ' . $d->getApellidoMat()), 1, 0, 'C', false);

            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(10, 7, utf8_decode('Número de teléfono: '), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(50, 7, utf8_decode($d->getTelefono()), 1, 0, 'C', false);

            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(30, 7, utf8_decode('Correo electrónico: '), 0, 0, 'L', false);
            $this->SetX(135);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(65, 7, utf8_decode($d->getEmail()), 1, 0, 'C', false);

            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(30, 7, utf8_decode('Reservación por:'), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(65, 7, utf8_decode($d->getTipoReservacion()), 1, 0, 'C', false);

            if ($d->getCveArea() != null) {
                $this->SetX(135);

                $this->Cell(65, 7, utf8_decode($d->getCveArea()->getDescripcion()), 1, 0, 'C', false);
            } else {

            }

            if ($d->getCveMesa() != null) {
                $this->SetX(135);

                $this->Cell(65, 7, utf8_decode($d->getCveMesa()->getCveMesa() . ' ' . $d->getCveMesa()->getDesMesa()), 1, 0, 'C', false);
            } else {

            }

            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(30, 7, utf8_decode('Tipo de evento:'), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(65, 7, utf8_decode($d->getCveEvento()->getDescripcion()), 1, 0, 'C', false);

            $this->Image('assets/media/logos/qr.jpeg', 177, 83, 25);


        }


        foreach ($datos as $dd) {
            $this->SetFont('helvetica', 'B', 10);
            $this->SetFont('helvetica', '', 10);
            $this->Ln();
            $this->SetY(170);
            $this->SetFillColor(255, 255, 255);
            $this->MultiCell(195, 80, "", 1, 'J', true); // Crear celda con bordes
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->SetXY(10, 170);
            $this->Cell(195, 7, utf8_decode('COMPROBANTE DE RESERVACIÓN'), 1, 0, 'C', true);
            $this->SetTextColor(0, 0, 0);

            $this->SetY(183);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(47, 7, utf8_decode('Fecha en la que se reservo'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecMov()->format('d')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecMov()->format('m')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($d->getFecMov()->format('Y')), 0, 0, 'C', false);

            $this->SetFont('helvetica', 'B', 10);
            $this->Cell(46, 7, utf8_decode('Fecha de reservación'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($dd->getFecReserva()->format('d')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($dd->getFecReserva()->format('m')), 0, 0, 'C', false);
            $this->SetFont('helvetica', '', 20);
            $this->Cell(5, 7, utf8_decode('/'), 0, 0, 'R', false);
            $this->SetFont('helvetica', '', 10);
            $this->Cell(13, 7, utf8_decode($dd->getFecReserva()->format('Y')), 0, 0, 'C', false);


            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(10, 7, utf8_decode('Nombre de la persona: '), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(150, 7, utf8_decode($dd->getNombre() . ' ' . $dd->getApellidoPat() . ' ' . $dd->getApellidoMat()), 1, 0, 'C', false);

            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(10, 7, utf8_decode('Número de teléfono: '), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(50, 7, utf8_decode($dd->getTelefono()), 1, 0, 'C', false);

            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(30, 7, utf8_decode('Correo electrónico: '), 0, 0, 'L', false);
            $this->SetX(135);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(65, 7, utf8_decode($dd->getEmail()), 1, 0, 'C', false);

            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(30, 7, utf8_decode('Reservación por:'), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(65, 7, utf8_decode($dd->getTipoReservacion()), 1, 0, 'C', false);

            if ($d->getCveArea() != null) {
                $this->SetX(135);

                $this->Cell(65, 7, utf8_decode($dd->getCveArea()->getDescripcion()), 1, 0, 'C', false);
            } else {

            }

            if ($d->getCveMesa() != null) {
                $this->SetX(135);

                $this->Cell(65, 7, utf8_decode($dd->getCveMesa()->getCveMesa() . ' ' . $dd->getCveMesa()->getDesMesa()), 1, 0, 'C', false);
            } else {

            }

            $this->Ln(10);
            $this->SetFont('helvetica', 'B', 10);

            $this->Cell(30, 7, utf8_decode('Tipo de evento:'), 0, 0, 'L', false);
            $this->SetX(50);
            $this->SetFont('helvetica', '', 10);

            $this->Cell(65, 7, utf8_decode($dd->getCveEvento()->getDescripcion()), 1, 0, 'C', false);

            $this->Image('assets/media/logos/qr.jpeg', 177, 223, 25);


        }

    }
}

