<?php

namespace App\Controller;

use Fpdf\Fpdf;

date_default_timezone_set('America/Mexico_City');

class PdfTicket extends Fpdf
{

    function generarNota($s, $datos)
    {
        $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);
        $this->Ln(20);
        $this->Cell(20, 5, utf8_decode("NOTA: "), 0, 0, 'R', false);
        $this->SetFont('Helvetica', 'B', 10);
        $this->Cell(0, 5, utf8_decode($s->getIdeSer()), 1, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('Helvetica', '', 10);
        $this->Cell(20, 5, utf8_decode("Mesa: " . $s->getCveMes()->getCveMesa()), 0, 0, 'L', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Cell(0, 5, utf8_decode("Fecha: " . $s->getFecMov()->format('d-m-Y')), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(22, 5, utf8_decode("H.E: " . $s->getHorMov()->format('H:i a')), 0, 0, 'L', false);
        if ($s->getHorCierre() == null) {
            $this->SetFont('Helvetica', 'B', 8);
            $this->Cell(0, 5, utf8_decode("H.S: ACTIVO"), 0, 0, 'R', false);
            $this->SetFont('Helvetica', '', 8);
        } else {
            $this->Cell(0, 5, utf8_decode("H.S: " . $s->getHorCierre()->format('H:i a')), 0, 0, 'R', false);
        }
        $this->Ln();
        $nomEmpleado = $s->getCveEmp()->getNomEmp() . " " . $s->getCveEmp()->getPriApe();
        $this->Cell(0, 5, utf8_decode("Atendió: " . $nomEmpleado));
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $sumaTotal = 0;
        foreach ($datos as $k => $d) {
            if (strlen($d['nomMen']) > 23) {
                $this->SetFont('Helvetica', '', 7);
            } else {
                $this->SetFont('Helvetica', '', 8);
            }
            $this->Cell(0, 5, utf8_decode($d['nomMen']), 1, 0, 'L', false);
            $this->SetFont('Helvetica', '', 8);
            $this->Ln();
            $this->Cell(14, 5, utf8_decode("$" . $d['precio']), 1, 0, 'R', false);
            $this->Cell(10, 5, utf8_decode($d['total']), 1, 0, 'C', false);
            $this->SetFont('Helvetica', 'B', 8);
            $this->Cell(20, 5, utf8_decode("$" . $d['subtotal']), 1, 0, 'R', false);
            $this->SetFont('Helvetica', '', 8);

            $this->Ln(7);
            $sumaTotal += $d['subtotal'];
        }
        $this->SetY(150);

        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('Helvetica', 'B', 9);
        $this->Cell(0, 5, utf8_decode("Total a pagar: $ " . number_format($sumaTotal, 2, '.', ',')), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('Helvetica', 'I', 8);
        $this->Cell(0, 5, utf8_decode("No Incluye El Servicio"), 0, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Ln();
        $this->Cell(0, 4, utf8_decode("Gracias Por Su Visita"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 4, utf8_decode("Vuelva Pronto"), 0, 0, 'C', false);
        $this->Image('assets/media/logos/logo-cardenal.png', 14, 180, 20);
    }

    function reciboIngreso($i)
    {
        /**
         * INICIA EL ENCABEZADO
         */
        $s = $i->getCveSerCue()->getCveSer();

        $this->Ln(20);
        $this->Cell(20, 5, utf8_decode("NOTA: "), 0, 0, 'R', false);
        $this->SetFont('Helvetica', 'B', 10);
        $this->Cell(0, 5, utf8_decode($s->getIdeSer()), 1, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);

        $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(18, 5, utf8_decode("RECIBO:"), 1, 0, 'R', false);
        $this->SetFont('Times', '', 10);
        $this->Cell(0, 5, utf8_decode("I-" . $i->getRecibo()), 1, 0, 'L', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Ln();
        $this->SetFont('Helvetica', '', 10);
        $this->Cell(20, 5, utf8_decode("Mesa: " . $s->getCveMes()->getCveMesa()), 0, 0, 'L', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Cell(0, 5, utf8_decode("Fecha: " . $s->getFecMov()->format('d-m-Y')), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(22, 5, utf8_decode("H.E: " . $s->getHorMov()->format('H:i a')), 0, 0, 'L', false);
        if ($s->getHorCierre() == null) {
            $this->SetFont('Helvetica', 'B', 8);
            $this->Cell(0, 5, utf8_decode("H.S: ACTIVO"), 0, 0, 'R', false);
            $this->SetFont('Helvetica', '', 8);
        } else {
            $this->Cell(0, 5, utf8_decode("H.S: " . $s->getHorCierre()->format('H:i a')), 0, 0, 'R', false);
        }

        $this->Ln();
        $nomEmpleado = $s->getCveEmp()->getNomEmp() . " " . $s->getCveEmp()->getPriApe();
        $this->Cell(0, 5, utf8_decode("Atendió: " . $nomEmpleado));
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        /**
         * TERMINA EL ENCABEZADO
         */
        $this->SetFont('Helvetica', 'B', 8);
        $this->Cell(0, 5, utf8_decode("RECIBO DE INGRESO"), 0, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("Total a Pagar:"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($i->getTotal(), 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("Pagó con:"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($i->getPagoCon(), 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("Forma de Pago:"), 0, 0, 'L', false);
        $this->Ln();
        $this->SetFont('Helvetica', 'B', 8);
        $this->Cell(0, 5, utf8_decode($i->getCveModPag()->getModoPago()), 0, 0, 'R', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("Cambio:"), 0, 0, 'L', false);
        $this->Ln();

        if ($i->getCveModpag()->getIdeModPag() == 1) {
            $this->Cell(0, 5, utf8_decode("$ " . number_format($i->getCambio(), 2, '.', ',')), 0, 0, 'R', false);
        } else {
            $this->Cell(0, 5, utf8_decode("NO APLICA"), 0, 0, 'R', false);
        }


        $this->Ln();
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Ln();
        $this->Ln();
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("--  --  --  --  --  --  --  --  --  --  --  --"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("DESPRENDER"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("--  --  --  --  --  --  --  --  --  --  --  --"), 0, 0, 'C', false);
        $this->Ln();
        $this->Ln();
        $this->Cell(20, 5, utf8_decode("NOTA: "), 0, 0, 'R', false);
        $this->SetFont('Helvetica', 'B', 10);
        $this->Cell(0, 5, utf8_decode($s->getIdeSer()), 1, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);
        $this->Cell(18, 5, utf8_decode("RECIBO:"), 1, 0, 'R', false);
        $this->SetFont('Times', '', 10);
        $this->Cell(0, 5, utf8_decode("I-" . $i->getRecibo()), 1, 0, 'L', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("Mesero: "), 0, 0, 'L', false);
        $this->Ln(4);
        $this->Cell(0, 2, utf8_decode($nomEmpleado), 0, 0, 'L', false);
        $this->Ln(10);
        $this->Cell(0, 2, utf8_decode("PROPINA:"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("_____________________________"), 0, 0, 'L', false);
        $this->Ln(10);
        $this->Cell(0, 2, utf8_decode("FIRMA:"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("_____________________________"), 0, 0, 'L', false);

        $this->Image('assets/media/logos/logo-cardenal.png', 14, 180, 20);

    }

    function corteDiario($ingreso, $fecha)
    {
        /**
         * INICIA EL ENCABEZADO
         */


        $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);
        $this->Ln(20);
        $this->Cell(0, 5, utf8_decode("FECHA DEL CORTE"), 0, 0, 'R', false);
        $this->Ln();
        $this->SetFont('Helvetica', 'B', 10);
        $this->Cell(0, 5, utf8_decode($fecha), 1, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln(4);
        /**
         * TERMINA EL ENCABEZADO
         */
        $sumEfectivo = 0;
        $sumTransferencia = 0;
        $sumPropinaEfectivo = 0;
        $sumPropinaTransferencia = 0;
        $sumaTotal = 0;

        if (count($ingreso) == 0) {
            $this->Ln(6);
            $this->Cell(0, 2, utf8_decode("SIN REGISTROS"), 0, 0, 'C', false);
            $this->Ln();
        } else {
            foreach ($ingreso as $k => $i) {
                $this->Cell(6, 2, utf8_decode("#" . $k + 1), 0, 0, 'L', false);
                $this->Cell(13, 2, utf8_decode("Mesa: " . $i->getCveSerCue()->getCveSer()->getCveMes()->getCveMesa()), 0, 0, 'L', false);
                $this->Cell(0, 2, utf8_decode("Nota: " . $i->getCveSerCue()->getCveSer()->getIdeSer()), 0, 0, 'R', false);
                $this->Ln(4);
                $this->Cell(0, 2, utf8_decode("Recibo: " . $i->getRecibo()), 0, 0, 'R', false);
                $this->Ln(4);
                $this->Cell(22, 2, utf8_decode("$" . $i->getTotal()), 0, 0, 'C', false);
                $this->Cell(0, 2, utf8_decode($i->getCveModPag()->getModoPago()), 0, 0, 'C', false);
                $this->Ln(4);
                $this->Cell(0, 2, utf8_decode("----------------------------------------"), 0, 0, 'C', false);
                $this->Ln(4);

                $this->Cell(22, 2, utf8_decode("PROPINA:"), 0, 0, 'L', false);
                $this->Ln(4);
                if ($i->isBanderaPropina() == 1) {
                    $this->Cell(22, 2, utf8_decode("$ " . number_format($i->getPropina(), 2, '.', ',')), 0, 0, 'L', false);
                    $this->Cell(0, 2, utf8_decode($i->getCveModPagPropina()->getModoPago()), 0, 0, 'C', false);

                    if ($i->getCveModPagPropina()->getIdeModPag() == 1) { // EFECTIVO
                        $sumPropinaEfectivo += $i->getPropina();
                    } else { // TRANSFERENCIA
                        $sumPropinaTransferencia += $i->getPropina();
                    }

                } else {
                    $this->Cell(0, 2, utf8_decode("SIN REGISTRO DE PROPINA"), 0, 0, 'C', false);
                }


                if ($i->getCveModPag()->getIdeModPag() == 1) { // EFECTIVO
                    $sumEfectivo += $i->getTotal();
                } else { // TRANSFERENCIA
                    $sumTransferencia += $i->getTotal();
                }


                $this->Ln();
                $this->Ln();
                $this->Ln();

            }

            $sumaTotal = $sumEfectivo + $sumTransferencia;
        }


        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("TOTAL EFECTIVO"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($sumEfectivo, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("TOTAL TRANSFERENCIA"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($sumTransferencia, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->SetFont('Helvetica', 'B', 8);
        $this->Cell(0, 2, utf8_decode("TOTAL GENERAL"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($sumaTotal, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->SetFont('Helvetica', '', 8);

        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("PROPINA EFECTIVO"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($sumPropinaEfectivo, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("PROPINA TRANSFERENCIA"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($sumPropinaTransferencia, 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->SetFont('Helvetica', 'B', 8);

        $this->Cell(0, 2, utf8_decode("TOTAL PROPINA:"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format(($sumPropinaEfectivo + $sumPropinaTransferencia), 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
    }

    function reciboPropina($i)
    {
        /**
         * INICIA EL ENCABEZADO
         */
        $s = $i->getCveSerCue()->getCveSEr();


        $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);
        $this->Ln(20);
        $this->Cell(20, 5, utf8_decode("NOTA: "), 0, 0, 'R', false);
        $this->SetFont('Helvetica', 'B', 10);
        $this->Cell(0, 5, utf8_decode($s->getIdeSer()), 1, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln(6);
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->SetFont('Helvetica', '', 10);
        $this->Cell(20, 5, utf8_decode("Mesa: " . $s->getCveMes()->getCveMesa()), 0, 0, 'L', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Cell(0, 5, utf8_decode("Fecha: " . $s->getFecMov()->format('d-m-Y')), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(22, 5, utf8_decode("H.E: " . $s->getHorMov()->format('H:i a')), 0, 0, 'L', false);
        if ($s->getHorCierre() == null) {
            $this->SetFont('Helvetica', 'B', 8);
            $this->Cell(0, 5, utf8_decode("H.S: ACTIVO"), 0, 0, 'R', false);
            $this->SetFont('Helvetica', '', 8);
        } else {
            $this->Cell(0, 5, utf8_decode("H.S: " . $s->getHorCierre()->format('H:i a')), 0, 0, 'R', false);
        }

        $this->Ln();
        $nomEmpleado = $s->getCveEmp()->getNomEmp() . " " . $s->getCveEmp()->getPriApe();
        $this->Cell(0, 5, utf8_decode("Atendió: " . $nomEmpleado));
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        /**
         * TERMINA EL ENCABEZADO
         */
        $this->SetFont('Helvetica', 'B', 8);
        $this->Cell(0, 5, utf8_decode("RECIBO DE PROPINA"), 0, 0, 'C', false);
        $this->SetFont('Helvetica', '', 8);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("Propina:"), 0, 0, 'L', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("$ " . number_format($i->getPropina(), 2, '.', ',')), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(0, 5, utf8_decode("Forma de Pago:"), 0, 0, 'L', false);
        $this->Ln();
        $this->SetFont('Helvetica', 'B', 8);
        $this->Cell(0, 5, utf8_decode($i->getCveModPagPropina()->getModoPago()), 0, 0, 'R', false);
        $this->SetFont('Helvetica', '', 8);

        $this->Ln();
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(0, 2, utf8_decode("**************************************"), 0, 0, 'C', false);
    }


    function buffetPorMes($serviciosBuffet, $mes)
    {
        /**
         * INICIA EL ENCABEZADO
         */
        $this->Image('assets/media/logos/logo-cardenal.png', 11.5, 2, 25);

        $this->SetFont('helvetica', 'B', '10');
        $this->Cell(250, 7, utf8_decode("REPORTE DEL MES"), 0, 0, 'R', false);
        $this->Ln();
        $this->Cell(250, 7, utf8_decode(date('m-Y')), 0, 0, 'R', false);

        $matrizDatos = [];

        $fecha = "";
        $auxDatos = "";

        if (count($serviciosBuffet) == 0) {

            $this->SetXY(25, 100);
            // $this->Image('assets/media/logos/adv.png', 80, 50, 100);
            $this->SetXY(70, 160);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(135, 163, 241);

            $this->Cell(120, 9, utf8_decode("NO HAY NINGÚN REGISTRO EN ESTA FECHA"), 1, 0, 'C', true);

        } else {
            $this->Ln(15);
            $this->SetX(20);
            $this->SetFont("", "B", 12);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Cell(35, 8, utf8_decode("FECHA"), 1, 0, 'C', true);
            $this->Cell(60, 8, utf8_decode("BUFFET VENDIDO"), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode("TOTAL POR BUFFET"), 1, 0, 'C', true);
            $this->Cell(45, 8, utf8_decode("TOTAL GENERAL"), 1, 0, 'C', true);


            $this->SetTextColor(0, 0, 0);
            $this->Ln();
            $this->SetFont('helvetica', '', '10');

            $datos = array();
            foreach ($serviciosBuffet as $ib) {
                $fecha = $ib['FECHA_DE_MOVIMIENTO']->format('d/m/Y');
                $tipo_menu = $ib['TIPO_MENU'];
                $nombre_menu = $ib['NOMBRE_MENU'];
                $total2 = $ib['TOTAL2'];
                if (!isset($datos[$fecha][$tipo_menu])) {
                    $datos[$fecha][$tipo_menu] = array(
                        'NOMBRE_MENU' => $nombre_menu,
                        'TOTAL2' => $total2
                    );
                } else {
                    $datos[$fecha][$tipo_menu]['TOTAL2'] += $total2;
                }
            }

            $this->SetX(70);
            foreach ($datos as $key => $d) {
                $this->SetX(20);
                $this->Cell(35, count($d) * 8, utf8_decode($key), 1, 0, 'C', false); // La altura de la celda se calcula en función del número de tipos de menú
                $totalPorBuffet = 0;
                $totalGeneral = 0;
                foreach ($d as $key => $dd) {
                    $totalPorBuffet += $dd['TOTAL2'];
                }
                $this->Cell(105, count($d) * 8, "", 0, 0, 'C', false);
                $this->Cell(45, count($d) * 8, ($totalPorBuffet), 1, 0, 'C', false);
                /*  foreach ($d as $key => $dd) {
                      $totalGeneral += $dd['TOTAL2'] + 1;
                  }
                  $this->Cell(45, count($d) * 8, ($totalGeneral), 1, 0, 'C', false);
  */

                foreach ($d as $key => $ddd) {
                    $this->SetX(55);
                    $this->Cell(60, 8, utf8_decode($ddd['NOMBRE_MENU']), 1, 0, 'J', false);
                    $this->Cell(45, 8, utf8_decode($ddd['TOTAL2']), 1, 0, 'C', false);
                    $this->Ln();
                }
                $this->Ln();
            }
        }

    }

    function imprimirGastosMes($g, $Mes)
    {
//FALTA COLOCAR EL MEMBRETADO
        $sumaGeneral = 0;


        $this->SetFont('helvetica', 'B', '8');
        $this->Cell(250, 7, utf8_decode("GASTOS DEL MES"), 0, 0, 'C', false);
        $this->Ln();
        $this->Cell(250, 8, $Mes, 0, 0, 'C', false);

        if (count($g) == 0) {
            $this->Cell(183, 8, utf8_decode('SIN REGISTROS EN EL MES'), 1, 0, 'C', false);
        } else {
            $this->SetFont("", "B", 10);
            $this->SetTextColor(255, 255, 255);
            $this->SetFillColor(48, 149, 124);
            $this->Ln(20);
            $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 10, utf8_decode('N°'), 1, 0, 'C', true);
            $this->Cell(45, 10, utf8_decode('Descripcion Gasto'), 1, 0, 'C', true);
            $this->Cell(22, 10, utf8_decode('Fecha.T'), 1, 0, 'C', true);
            $this->Cell(24, 10, utf8_decode('Hora T'), 1, 0, 'C', true);
            $this->Cell(35, 10, utf8_decode('Fecha Movimiento'), 1, 0, 'C', true);
            $this->Cell(30, 10, utf8_decode('Hora de M'), 1, 0, 'C', true);
            $this->Cell(27, 10, utf8_decode('Total Monto'), 1, 0, 'C', true);
            $this->Ln(10);
            $this->SetFont("", "", 8);
            $this->SetTextColor(0, 0, 0);

            foreach ($g as $k => $t) {
                $sumaGeneral = $sumaGeneral + $t->getTotMon();

                $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
                $this->Cell(20, 10, utf8_decode($k + 1), 1, 0, 'C', false);

                if ($t->getCveCatGast() == null) {
                    $this->Cell(45, 10, utf8_decode(""), 1, 0, 'L', false);
                } else {
                    $this->Cell(45, 10, utf8_decode($t->getCveCatGast()->getDescripcion()), 1, 0, 'L', false);
                }
                $this->Cell(22, 10, utf8_decode($t->getFecMovGast()->format('d/m/Y')), 1, 0, 'R', false);
                $this->Cell(24, 10, utf8_decode($t->getHorMovGast()->format('H:i')), 1, 0, 'R', false);
                $this->Cell(35, 10, utf8_decode($t->getFecMov()->format('Y/m/d')), 1, 0, 'C', false);
                $this->Cell(30, 10, utf8_decode($t->getHorMov()->format('H:i')), 1, 0, 'R', false);
                $this->Cell(27, 10, utf8_decode('$' . $t->getTotMon()), 1, 0, 'R', false);
                $this->Ln();


            }
            $this->SetFont("", "B", 9);
            $this->SetFillColor(48, 149, 124);
            $this->SetTextColor(255, 255, 255);
            $this->Cell(35, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(20, 10, utf8_decode(''), 0, 0, 'C', false);
            $this->Cell(156, 10, utf8_decode('TOTAL GASTOS MES:'), 1, 0, 'L', true);
            $this->Cell(27, 10, '$' . number_format($sumaGeneral, 2, "."), 1, 0, 'R', true);
        }
    }


}

