<?php

namespace App\Controller;

use App\Entity\ModoPagos;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\UX\Chartjs\Builder\ChartBuilderInterface;
use Symfony\UX\Chartjs\Model\Chart;
use App\Entity\ServiciosMenu;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use App\Entity\Servicios;
use App\Entity\Menus;
use App\Entity\Ingresos;


date_default_timezone_set('America/Mexico_City');

class ReportesController extends AbstractController
{
    #[Route('/grafica', name: 'grafica')]
    public function getGrafica(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'GET') {
                $em = $doctrine->getManager();

                // $serviciosMenu = $em->getRepository(ServiciosMenu::class)->findAll();
                $fechaActual = new \DateTime();

                $fechaA = $fechaActual->format('Y-m-01');

                // Obtiene el último día del mes actual
                $ultimoDiaMes = $fechaActual->format('t');
                $fechaB = $fechaActual->format('Y-m-' . $ultimoDiaMes);

                $dql = "SELECT "
                    . "s.fecMov FECHA_DE_MOVIMIENTO, "
                    . "COUNT(s.ideSer) TOTAL1, "
                    . "IDENTITY(sm.cveMen) TIPO_MENU, "
                    . "m.nomMen NOMBRE_MENU, "
                    . "COUNT(IDENTITY(sm.cveMen)) TOTAL2 "
                    . "FROM "
                    . "App\Entity\Servicios s, "
                    . "App\Entity\ServiciosMenu sm, "
                    . "App\Entity\Menus m "
                    . "WHERE "
                    . "s.ideSer = sm.cveSer "
                    . "AND "
                    . "sm.cveMen = m.ideMen "
                    . "AND "
                    . "s.fecMov BETWEEN '" . $fechaA . "' AND '" . $fechaB . "' "
                    . "GROUP BY "
                    ."sm.cveMen";

                $query = $entityManager->createQuery($dql);
                $gastos = $query->getResult();


                // ... (tu código anterior)

                $datos = [];
                foreach ($gastos as $g) {
                    $datos[] = [
                        'fecha' => $g['FECHA_DE_MOVIMIENTO']->format('Y-m-d'),
                        'menu' => $g['NOMBRE_MENU'],
                        'total' => $g['TOTAL1']
                    ];
                }

                return new JsonResponse($datos);


            }
        }


    }


    #[Route('/verGrafica', name: 'ver-grafica')]
    public function verGrafica(Request $request, ManagerRegistry $doctrine): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {

            } else {
                return $this->render('Reportes/reporte_grafica.html.twig');
            }
        }

    }

    #[Route('/imprimirTicketPagadosDia', name: 'ticket_pagado_dia')]
    public function imprimirTicketPagadosDia(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $fecha = $request->get('fecha');

                if ($fecha == null) {
                    $hoy = date('Y-m-d');
                } else {
                    $hoy = date($fecha);
                }
                /*
$ideModoPago = $em->getRepository('ideModPag');
$cveModPag = $em->getRepository(ModoPagos::class)
    ->findBy(['ideModPag' => $ideModoPago]);
SELECT
s.ide_ser AS IDE_SERVICIO,
servicios_cuenta.total AS TOTAL_PAGADO,
(CASE WHEN ingresos.total IS NULL THEN 'null' ELSE ingresos.total END) AS TOTAL_INGRESOS,
s.fec_mov AS FECHA_MOV,
ingresos.fec_mov AS FECHA_INGREOS,
s.hor_cierre AS HORA_SERVICIO,
ingresos.hor_mov AS HORA_PAGO
FROM servicios s
JOIN servicios_cuenta ON s.ide_ser = servicios_cuenta.cve_ser
LEFT JOIN ingresos ON ingresos.cve_ser_cue = servicios_cuenta.ide_ser_cue
                AND ingresos.fec_mov = '2023-05-05'
WHERE s.fec_mov = '2023-05-05';*/

                $ingresos = $em->getRepository(Ingresos::class)
                    ->findBy(['fecMov' => new \DateTime($hoy)]);

                $dql = "SELECT "
                    . "s.ideSer IDE_SERVICIO, "
                    . "sc.total TOTAL_PAGO, "
                    . "(CASE WHEN i.total IS NULL THEN 'SIN_PAGO' ELSE i.total END) TOTAL_RECIBIDO, "
                    . "s.fecMov FECHA_MOV, "
                    . "i.fecMov FECHA_INGRESOS, "
                    . "s.horCierre HORA_SERVICIO, "
                    . "i.horMov HORA_PAGO, "
                    . "m.modoPago MODO_PAGO "
                    . "FROM App\Entity\Servicios s "
                    . "LEFT JOIN App\Entity\ServiciosCuenta sc "
                    . "WITH "
                    . "s.ideSer = sc.cveSer "
                    . "LEFT JOIN App\Entity\Ingresos i "
                    . "WITH "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "JOIN App\Entity\ModoPagos m "
                    . "WITH "
                    . " m.ideModPag = i.cveModPag "
                    . "WHERE "
                    . "s.fecMov = "
                    . "'" . $hoy . "'";
                $query = $entityManager->createQuery($dql);
                $ticketPagado = $query->getResult();

                /*
                                $dql1 = "SELECT"
                                    . "i.cveModPag IN(1) MODO_PAGO, "
                                    . "i.total TOTAL "
                                    . "FROM App\Entyti\Ingresos i "
                                    . "WHERE "
                                    . "i.fecMov = "
                                    . "'" . $hoy . "' ";
                                $query = $entityManager->createQuery($dql1);
                                $ticketPago = $query->getResult();*/

                $pdf = new PdfReportes('P', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->corteDelDiaTicket($ticketPagado, $hoy, $ingresos);


                return new Response(
                    $pdf->Output('ticketPagado_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCorteDiaTickte', name: 'imprimir_corte_Dia_Ticket')]
    public function imprimirCorteDiaTickte(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET

                $em = $doctrine->getManager();

                $fecha = $request->get('corteTicketDia');

                if ($fecha == null) {
                    $hoy = date('d-m-Y');
                } else {
                    $hoy = date($fecha);
                }
                $ingresos = $em->getRepository(Ingresos::class)
                    ->findBy(['fecMov' => new \DateTime($hoy)]);

                $dql = "SELECT "
                    . "s.ideSer IDE_SERVICIO, "
                    . "sc.total TOTAL_PAGO, "
                    . "(CASE WHEN i.total IS NULL THEN '*SIN_PAGO*' ELSE i.total END) TOTAL_RECIBIDO, "
                    . "s.fecMov FECHA_MOV, "
                    . "i.fecMov FECHA_INGRESOS, "
                    . "s.horCierre HORA_SERVICIO, "
                    . "m.modoPago MODO_PAGO, "
                    . "i.horMov HORA_PAGO "
                    . "FROM App\Entity\Servicios s "
                    . "LEFT JOIN App\Entity\ServiciosCuenta sc "
                    . "WITH "
                    . "s.ideSer = sc.cveSer "
                    . "LEFT JOIN App\Entity\Ingresos i "
                    . "WITH "
                    . "i.cveSerCue = sc.ideSerCue "
                    . "JOIN App\Entity\ModoPagos m "
                    . "WITH "
                    . " m.ideModPag = i.cveModPag "
                    . "WHERE "
                    . "s.fecMov = "
                    . "'" . $hoy . "'"
                    . "ORDER BY s.ideSer ";
                $query = $entityManager->createQuery($dql);
                $cortePorDiaTicket = $query->getResult();


                $pdf = new PdfReportes('P', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->corteDiaTicket($cortePorDiaTicket, $hoy, $ingresos);
                return new Response(
                    $pdf->Output('corteDiaTicket_' . $hoy . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCorteMesTickte', name: 'imprimir_corte_Mes_Ticket')]
    public function imprimirCorteMesTickte(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET

                $em = $doctrine->getManager();

                $Mes = $request->get('corteMes');
                $primer_Dia = $Mes . "-01";
                $Ultimo_dia = new \DateTime($primer_Dia);
                $Ultimo_dia->modify('Last day of this month');

                /* $ingresos = $em->getRepository(Ingresos::class)
                     ->findBy(['fecMov' => new \DateTime($hoy)]);*/
                /*
                                $dql = "SELECT "
                                    . "s.ideSer IDE_SERVICIO, "
                                    . "sc.total TOTAL_PAGO, "
                                    . "(CASE WHEN i.total IS NULL THEN '*SIN_PAGO*' ELSE i.total END) TOTAL_RECIBIDO, "
                                    . "s.fecMov FECHA_MOV, "
                                    . "i.fecMov FECHA_INGRESOS, "
                                    . "s.horCierre HORA_SERVICIO, "
                                    . "m.modoPago MODO_PAGO, "
                                    . "i.horMov HORA_PAGO "
                                    . "FROM App\Entity\Servicios s "
                                    . "LEFT JOIN App\Entity\ServiciosCuenta sc "
                                    . "WITH "
                                    . "s.ideSer = sc.cveSer "
                                    . "LEFT JOIN App\Entity\Ingresos i "
                                    . "WITH "
                                    . "i.cveSerCue = sc.ideSerCue "
                                    . "JOIN App\Entity\ModoPagos m "
                                    . "WITH "
                                    . " m.ideModPag = i.cveModPag "
                                    . "WHERE "
                                    . "s.fecMov "
                                    . "BETWEEN "
                                    . "'" . $primer_Dia . "' "
                                    . "AND "
                                    . "'" . $Ultimo_dia->format('Y/m/d') . "'";
                */
                $dql = "SELECT i "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE "
                    . "i.fecMov "
                    . "BETWEEN "
                    . "' " . $primer_Dia . "' "
                    . "AND "
                    . "' " . $Ultimo_dia->format('Y-m-d') . "'";

                $query = $entityManager->createQuery($dql);
                $cortePorDiaTicket = $query->getResult();


                $pdf = new PdfReportes('P', 'mm', 'Letter');
                $pdf->SetFont('Helvetica', '', 8);
                $pdf->AddPage();
                $pdf->SetLeftMargin(0);
                $pdf->SetRightMargin(4);
                $pdf->CorteMes($cortePorDiaTicket);
                return new Response(
                    $pdf->Output('corteDiaTicket_' . $Mes . '.pdf', 'I'),
                    200,
                    array('Content-Type' => 'application/pdf')
                );

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

    #[Route('/imprimirCorteDiaTickectContenedor', name: 'imprimir_corte_Dia_Ticket_Contenedor')]
    public function imprimirCorteDiaTickectContenedor(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET

                $em = $doctrine->getManager();

                $fecha = $request->get('fecha');

                if ($fecha == null) {
                    $hoy = date('d-m-Y');
                } else {
                    $hoy = date($fecha);
                }
                /*

                                $dql = "SELECT "
                                    . "s.ideSer IDE_SERVICIO, "
                                    . "sc.total TOTAL_PAGO, "
                                    . "(CASE WHEN i.total IS NULL THEN '*SIN_PAGO*' ELSE i.total END) SUBTOTAL, "
                                    . "s.fecMov FECHA_MOV, "
                                    . "i.fecMov FECHA_INGRESOS, "
                                    . "s.horCierre HORA_SERVICIO, "
                                    . "i.horMov HORA_PAGO "
                                    . "FROM App\Entity\Servicios s "
                                    . "JOIN App\Entity\ServiciosCuenta sc "
                                    . "WITH "
                                    . "s.ideSer = sc.cveSer "
                                    . "JOIN App\Entity\Ingresos i "
                                    . "WITH "
                                    . "i.cveSerCue = sc.ideSerCue "
                                    . "WHERE "
                                    . "s.fecMov = "
                                    . "'" . $hoy . "'";

                                $query = $entityManager->createQuery($dql);
                                $cortePorDiaTicket = $query->getResult();


                                 $cortePorDiaTicket = $em->getRepository(Ingresos::class)
                                     ->findBy(['fecMov' => new \DateTime($hoy)]);*/
                $dql = "SELECT s.ideSer AS IDE_SERVICIO, "
                    . "sc.total AS TOTAL_PAGO, "
                    . "(CASE WHEN i.total IS NULL THEN '*SIN_PAGO*' ELSE i.total END) AS SUBTOTAL, "
                    . "s.fecMov AS FECHA_MOV, "
                    . "i.fecMov AS FECHA_INGRESOS, "
                    . "s.horCierre AS HORA_SERVICIO, "
                    . "i.horMov AS HORA_PAGO "
                    . "FROM App\Entity\Servicios s "
                    . "JOIN App\Entity\ServiciosCuenta sc "
                    . "WITH s.ideSer = sc.cveSer "
                    . "JOIN App\Entity\Ingresos i "
                    . "WITH i.cveSerCue = sc.ideSerCue "
                    . "WHERE s.fecMov = :hoy";

                $query = $entityManager->createQuery($dql);
                $query->setParameter('hoy', $hoy);
                $cortePorDiaTicket = $query->getResult();

                return $this->render('Pagos/contenedor-dia-ticket.html.twig', [
                    'ingresos' => $cortePorDiaTicket]);

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }


    #[Route('/ingresos', name: 'ingresos')]
    public function ingresos(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                return $this->redirect($this->generateUrl('login'));
            } else { // ES GET
                $em = $doctrine->getManager();

                $fecha = $request->query->get('fecha');
                $primerDia = (new \DateTime($fecha))->modify('first day of this month')->format('Y/m/d');
                $ultimoDia = (new \DateTime($fecha))->modify('last day of this month')->format('Y/m/d');

                $dql = "SELECT "
                    . "i.fecMov FECHA, "
                    . "COUNT(i.ideIng) TOTAL_SER, "
                    . "SUM(i.total) TOTAL_INGRESOS "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE i.fecMov "
                    . "BETWEEN "
                    . "' " . $primerDia . "' "
                    . "AND "
                    . "' " . $ultimoDia . "' "
                    . "AND "
                    . "i.cveModPag IN(SELECT m.ideModPag FROM App\Entity\ModoPagos m WHERE i.cveModPag IN (1) ) "
                    . "GROUP BY i.fecMov";
                $query = $entityManager->createQuery($dql);
                $moda = $query->getResult();

                return $this->render('Reportes/contenedor-moda-ingresos.html.twig',
                    [
                        'moda' => $moda
                    ]);
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }


    #[Route('/modaIngresos', name: 'moda-ingresos')]
    public function modaIngresos(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $fecha = $request->request->get('fecha');
                $primerDia = (new \DateTime($fecha))->modify('first day of this month')->format('Y/m/d');
                $ultimoDia = (new \DateTime($fecha))->modify('last day of this month')->format('Y/m/d');

                $dql = "SELECT "
                    . "i.fecMov FECHA, "
                    . "COUNT(i.ideIng) TOTAL_SER, "
                    . "SUM(i.total) TOTAL_INGRESOS "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE i.fecMov "
                    . "BETWEEN "
                    . "'" . $primerDia . "' "
                    . "AND "
                    . "'" . $ultimoDia . "' "
                    . "GROUP BY i.fecMov";
                $query = $entityManager->createQuery($dql);
                $moda = $query->getResult();

                return $this->render('Reportes/media-ingresos.html.twig',
                    [
                        'moda' => $moda
                    ]);
            } else { // ES GET
                // Resto del código
            }
        } else {
            // Resto del código
        }
    }

    #[
        Route('/mediaIngresos', name: 'media-ingresos')]
    public function mediaIngresos(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
            } else { // ES GET

                $em = $doctrine->getManager();

                $Mes = $request->get('corteMes');
                $primer_Dia = $Mes . "-01";
                $Ultimo_dia = new \DateTime($primer_Dia);
                $Ultimo_dia->modify('Last day of this month');

                $fechaInicio = "2023-04-01";
                $fechaFin = "2023-04-30";

                $dql = "SELECT "
                    . "i.fecMov FECHA, "
                    . "COUNT(i.ideIng) TOTAL_SER, "
                    . "SUM(i.total) TOTAL_INGRESOS "
                    . "FROM App\Entity\Ingresos i "
                    . "WHERE i.fecMov "
                    . "BETWEEN "
                    . "' " . $primer_Dia . "' "
                    . "AND "
                    . "' " . $Ultimo_dia->format('Y-m-d') . "' "
                    . "GROUP BY i.fecMov";
                $query = $entityManager->createQuery($dql);
                $moda = $query->getResult();

                return $this->render('Reportes/media-ingresos.html.twig',
                    [
                        'moda' => $moda
                    ]);

            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }
    }

}
