<?php

namespace App\Controller;

use App\Entity\CategoriasMenu;
use App\Entity\Empleados;
use App\Entity\Menus;
use App\Entity\Mesas;
use App\Entity\Servicios;
use App\Entity\TiposServicio;
use App\Entity\Usuarios;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

date_default_timezone_set('America/Mexico_City');

class SeguridadController extends AbstractController
{
    #[Route('/', name: 'home_page')]
    public function index(Request $request, ManagerRegistry $doctrine, EntityManagerInterface $entityManager): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            if ($request->getMethod() == 'POST') {
            } else { // ES GET
                $rol = $session->get('rolUser');
                $em = $doctrine->getManager();

                switch ($rol) {
                    case 1: // ADMINISTRADOR(ROOT)
                        break;
                    case 2: // GERENTE CARDENAL (Para registrar todos los movimientos de servicios)

                        $menus = $em->getRepository(Menus::class)->findAll();
                        $mesas = $em->getRepository(Mesas::class)->findAll();
                        $empleados = $em->getRepository(Empleados::class)->findBy(['estatus' => 1], ['nomEmp' => 'ASC']);

                        $dql = "SELECT m "
                            . "FROM App\Entity\Mesas m "
                            . "WHERE  m.ideMes "
                            . "NOT  IN( SELECT IDENTITY(s.cveMes) FROM App\Entity\Servicios s WHERE s.estatus = 1)";
                        $query = $entityManager->createQuery($dql);
                        $mesasDisponibles = $query->getResult();

                        $servicios = $em->getRepository(Servicios::class)->findBy(['estatus' => 1], ['cveMes' => 'ASC']);
                        $tipoServicios = $em->getRepository(TiposServicio::class)->findAll();

                        $categoriasMenu = $em->getRepository(CategoriasMenu::class)->findAll();

                        $datosMenu = [];

                        foreach ($categoriasMenu as $v) {
                            $auxMenus = $em->getRepository(Menus::class)->findBy(['cveCatMen' => $v]);
                            $datosMenu[] = [$v, $auxMenus];
                        }

                        return $this->render('Gerente/gerente_home_page.html.twig',
                            [
                                'menus' => $menus, 'mesas' => $mesas, 'empleados' => $empleados,
                                'servicios' => $servicios, 'tipoServicios' => $tipoServicios,
                                'datosMenu' => $datosMenu, 'mesasDisponibles' => $mesasDisponibles
                            ]
                        );
                        break;
                    case 3: // FINANZAS CARDENAL (Para registrar todos los movimientos de servicios)


                        return $this->render('Gerente/finanzas_home_page.html.twig',
                            [

                            ]
                        );
                        break;

                    default:

                        break;
                }
            }
        } else {
            return $this->redirect($this->generateUrl('login'));
        }

    }

    #[Route('/login', name: 'login')]
    public function login(Request $request): Response
    {
        $session = $request->getSession();
        if ($session->has('ideUsuario')) {
            return $this->redirect($this->generateUrl('home_page'));
        } else {
            return $this->render('Seguridad/login.html.twig');
        }
    }

    #[Route('/check', name: 'login_check')]
    public function check(Request $request, ManagerRegistry $doctrine): Response
    {
        $session = $request->getSession();
        //PRIMERO: Validamos que la sesión no haya iniciado sesión
        if ($session->has('ideUsuario')) {
            // SI ESTÁ LOGEADO, entonces, redirigir a la página inicial
            return $this->redirect($this->generateUrl('home_page'));
        } else {
            //NO ESTÁ LOGEADO, entonces, validar el tipo de Método de Solicitud.
            if ($request->getMethod() == 'POST') {
                $em = $doctrine->getManager();

                $usuario = $request->get('username');
                $password = $request->get('password');

                $user = $em->getRepository(Usuarios::class)
                    ->findOneBy(['userName' => $usuario, 'password' => $password]);

                if ($user) {//Validar si el usuario existe
                    $session->set('ideUsuario', $user->getIdeUsu());
                    $session->set('userName', $user->getNomUsu());
                    $session->set('priApe', $user->getPriApe());
                    $session->set('rolUser', $user->getRolUsuer());

                    $session->getFlashBag()->add('mensaje', 'Bienvenido!!');

                    return $this->redirect($this->generateUrl('home_page'));
                } else {
                    $session->getFlashBag()->add('mensaje', 'El usuario o contraseña, son incorrectos.');

                    return $this->redirect($this->generateUrl('login'));
                }

            } else { // ES GET
                //Redirigir a la página de Login
                return $this->redirect($this->generateUrl('login'));
            }

        }
    }

    #[Route('logout', name: 'logout')]
    public function logout(Request $request): Response
    {
        $session = $request->getSession();
        $session->clear();

        $session->getFlashBag()->add('mensaje', 'Ha cerrado su sesión.');

        return $this->redirect($this->generateUrl('login'));
    }
}